#ifndef MAPLE_VIDEO_DRV_H
#define MAPLE_VIDEO_DRV_H

#ifdef CC_PowerCons_Ctrl
#include "sony_PowerConsumptionCtrl.h"
#include "../../pcmcia/pcmcia_if.h"
#include "../../pcmcia/pcmcia_hw.h"
#endif 

typedef enum
{
    E_NR_CUST_ADAP_NL    = 0,
    E_NR_CUST_ADAP_XNR   = 1,
    E_NR_CUST_ADAP_RNR   = 2,
    E_NR_CUST_ADAP_MOANR = 3,
    E_NR_CUST_ADAP_FUNC_MAX
} E_NR_DFT_ADAP_FUNC;


typedef enum
{
    E_SCE_VIVID = 0,
    E_SCE_ST_OFF,
    E_SCE_ST_LOW,
    E_SCE_ST_MID,
    E_SCE_ST_HIGH,
    E_SCE_CI_LOW,
    E_SCE_CI_MID,
    E_SCE_CI_HIGH,
    E_SCE_PH_LOW,
    E_SCE_PH_MID,
    E_SCE_PH_HIGH,
    E_SCE_VIVID_BT2020,
    E_SCE_ST_OFF_BT2020,
    E_SCE_ST_LOW_BT2020,
    E_SCE_ST_MID_BT2020,
    E_SCE_ST_HIGH_BT2020,
    E_SCE_CI_LOW_BT2020,
    E_SCE_CI_MID_BT2020,
    E_SCE_CI_HIGH_BT2020,
    E_SCE_PH_LOW_BT2020,
    E_SCE_PH_MID_BT2020,
    E_SCE_PH_HIGH_BT2020,
    E_SCE_HLG_Off,
    E_SCE_HLG_Low,
    E_SCE_HLG_Mid,
    E_SCE_HLG_High,
    E_SCE_DV_OFF,
    E_SCE_DV_LOW,
    E_SCE_DV_MID,
    E_SCE_DV_HIGH,
} E_CUST_SCE_MODE;

typedef enum
{
    E_LCE_VIVID = 0,
    E_LCE_ST_OFF,
    E_LCE_ST_LOW,
    E_LCE_ST_MID,
    E_LCE_ST_HIGH,
    E_LCE_CI_LOW,
    E_LCE_CI_MID,
    E_LCE_CI_HIGH,
    E_LCE_PH_LOW,
    E_LCE_PH_MID,
    E_LCE_PH_HIGH,
    E_LCE_VIVID_HDR10,
    E_LCE_ST_OFF_HDR10,
    E_LCE_ST_LOW_HDR10,
    E_LCE_ST_MID_HDR10,
    E_LCE_ST_HIGH_HDR10,
    E_LCE_CI_LOW_HDR10,
    E_LCE_CI_MID_HDR10,
    E_LCE_CI_HIGH_HDR10,
    E_LCE_PH_LOW_HDR10,
    E_LCE_PH_MID_HDR10,
    E_LCE_PH_HIGH_HDR10,
    E_LCE_VIVID_HLG,
    E_LCE_ST_OFF_HLG,
    E_LCE_ST_LOW_HLG,
    E_LCE_ST_MID_HLG,
    E_LCE_ST_HIGH_HLG,
    E_LCE_CI_LOW_HLG,
    E_LCE_CI_MID_HLG,
    E_LCE_CI_HIGH_HLG,
    E_LCE_PH_LOW_HLG,
    E_LCE_PH_MID_HLG,
    E_LCE_PH_HIGH_HLG,
    E_LCE_DV_VIVID,
    E_LCE_DV_OFF,
    E_LCE_DV_LOW,
    E_LCE_DV_MID,
    E_LCE_DV_HIGH,
} E_CUST_LCE_MODE;

typedef enum
{
    E_SCE_UI_OFF = 0,
    E_SCE_UI_LOW,
    E_SCE_UI_MID,
    E_SCE_UI_HIGH,
} E_CUST_SCE_UI_MODE;

typedef enum
{
    E_SMART_PIC_VIVID,
    E_SMART_PIC_STANDARD,
    E_SMART_PIC_CINEMA,
    E_SMART_PIC_GAME,
    E_SMART_PIC_GRAPHICS,
    E_SMART_PIC_PHOTO,
    E_SMART_PIC_CUSTOM,
    E_SMART_PIC_USER1,
    E_SMART_PIC_USER2,
    E_SMART_PIC_DV_DARK,
    E_SMART_PIC_DV_BRIGHT,
    E_SMART_PIC_DV_VIVIDE,
    E_SMART_PIC_NETFLIX_DV,
    E_SMART_PIC_NETFLIX_SDR,
    E_SMART_PIC_RESERVED_1,
    E_SMART_PIC_RESERVED_2,
} E_CUST_SMART_PIC_MODE;

typedef enum
{
    E_CT_COOL = 0,
    E_CT_NEUTRAL,
    E_CT_WARM1,
    E_CT_WARM2,
    E_CT_PHOTO,
    E_CT_MAX,
} E_CUST_COLOR_TEMP_MODE;

enum
{
    DEMO_PQ_OFF      = 0,
    DEMO_PQ_ON_RIGHT = 1,
    DEMO_PQ_ON_LEFT  = 2
};

enum
{
    E_OSTG_MODULE_ALL = 0x0,
    E_OSTG_MODULE_XVYCC2,
    E_OSTG_MODULE_LCD,
    E_OSTG_MODULE_DITHER_BEFORE_OPTION3,
    E_OSTG_MODULE_GAMMA_OPTION3,
    E_OSTG_MODULE_DITHER_AFTER_OPTION3,
    E_OSTG_MODULE_R2Y
};

typedef struct _WB_TEST_PTN_STATUS{
    UINT8 u1PtnOnOff;
    UINT8 u1BlueStretchOnOff;
    UINT8 u1XvYccOnOff;
    UINT8 u1OPCOnOff;
    UINT8 u1MuteOnOff;  
    UINT8 u1LDOnOff;
    UINT8 u1PreDitherSel;
    UINT8 u1PostDitherSel;
    UINT8 u1ODOnOff;
} WB_TEST_PTN_STATUS;

enum
{
    SCAL_COEF_HY,
    SCAL_COEF_HC,
    SCAL_COEF_VY,
    SCAL_COEF_VC,
    SCAL_COEF_MAX,
};

#endif /* MAPLE_VIDEO_DRV_H */
