/******************************************************************************
 *
 * Copyright 2017, Lattice Semiconductor, Inc. All rights reserved.
 * No part of this work may be reproduced, modified, distributed, transmitted,
 * transcribed, or translated into any language or computer format, in any form
 * or by any means without written permission of Lattice Semiconductor Inc.,
 * 111 SW 5th Ave, Suite 700, Portland, OR 97204.
 *
 *****************************************************************************/
/**
 * @file sii_sys_malloc.c
 *
 * @brief Dynamic memory allocation from static memory pool
 *
 *****************************************************************************/

#ifndef SI_SYS_MALLOC_API_H
#define SI_SYS_MALLOC_API_H

/***** #include statements ***************************************************/

#include "sii_datatypes.h"

/***** public functions ******************************************************/

void *sii_sys_malloc_create(uint16_t size);
void sii_sys_malloc_delete(void *p);
uint16_t sii_sys_malloc_bytes_allocated_get(void);
void sii_sys_malloc_lock(void);
void sii_sys_malloc_delete_all(void);

#endif /* SI_SYS_MALLOC_API_H */

/***** end of file ***********************************************************/
