/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


/*-----------------------------------------------------------------------------
 * Copyright (c) 2005, MediaTek, Inc.
 * All rights reserved.
 *
 * Unauthorized use, practice, perform, copy, distribution, reproduction,
 * or disclosure of this information in whole or in part is prohibited.
 *-----------------------------------------------------------------------------
 *
 * $Author: binghe.li $
 * $Date: 2016/05/12 $
 * $RCSfile: drv_mjc_hw.h $
 * $Revision: #8 $
 *
 *----------------------------------------------------------------------------*/

#ifndef _DRV_MJC_HW_H_
#define _DRV_MJC_HW_H_

/*----------------------------------------------------------------------------*
 * Header Files
*----------------------------------------------------------------------------*/
#include "hw_mjc_pre.h"
#include "hw_mjc_cmq.h"
#include "hw_mjc_post.h"
#include "hw_mjc_core.h"
#include "typedef.h"
#include "feature.h"



/*====================End  Header Files ============================*/

/*----------------------------------------------------------------------------*
 * Definitions
 *----------------------------------------------------------------------------*/
#define MJC_REG_TBL_END 0xffffffff


typedef struct 
{	
    UINT32 u4Reg;	
    UINT32 u4Value;	
    UINT32 u4Mask;
} MJCREGTBL_T;




/*====================End  Definitions ============================*/
/*----------------------------------------------------------------------------*
 * Global/Static variables
 *----------------------------------------------------------------------------*/



/*====================End Global/Static variables =====================*/

/*----------------------------------------------------------------------------*
 * Function Members
 *----------------------------------------------------------------------------*/ 

void vDrvMJCLoadRegTbl(MJCREGTBL_T const * pRegTbl) reentrant;

void vDrvMJCWDMAFIFOWalkaroundES1(void);
void vDrvMJCRDMAB2RNot420MWalkaroundES1(UINT8 u1OnOff);
void vDrvMJCColorDepthLoseWalkaroundES1(UINT8 u1OnOff);
void vDrvMJCSetOnOff(UINT8 u1OnOff);
UINT8 u1DrvMJCGetOnOffStatus(void);
void vDrvMJCSetCoreClockEN(UINT8 u1COnOff);
void vDrvMJCSetDramClockEN(UINT8 u1DOnOff);
void vDrvMJCSetPOCLKEN(UINT8 u1POnOff);
void vDrvMJCSetOCLKEN(UINT8 u1OCLKOnOff);
void vDrvMJCCoreSetISRClr(UINT32 u4Clear);
void vDrvMJCCoreSetMcIntpMode(UINT32 u4McIntpMode);


void vDrvMJCPreSetRepeatEN(UINT8 u1RPOnOff);
UINT8 vDrvMJCPreGetRepeatEN(void);
void vDrvMJCPreSetRepeatMode(UINT8 u1RPmode);
void vDrvMJCPreSet10BitMode(UINT8 u1BitMode);
void vDrvMJCPreSetRGBToYUV(UINT8 u1OnOff);
void vDrvMJCPreSetDramEN (UINT8 u1DramOnOff);
UINT8 u1DrvMJCPreGetDramEN (void);
void vDrvMJCPreSelectDramAddr(UINT8 u1flg);
void vDrvMJCPreSetDramAddr(UINT32 u4Yaddr,UINT32 u4Caddr);
void vDrvMJCPreSet444To420(UINT8 u1OnOff);
void vDrvMJCPreSetDramUltraEN(UINT8 u1OnOff);
void vDrvMJCPreSetDramUltraTHR(UINT32 u4Y, UINT32 u4C);
void vDrvMJCPreSelectCMQTrg(UINT8 u1mode);
UINT8 vDrvMJCPreGetFilmInfo(void);
void vDrvMJCPreSetSWReset(UINT8 u1Mode);
void vDrvMJCPreSetVtotal(UINT16 u2Vtotal);
void vDrvMJCPreSetPreultra(UINT8 u1PreUltOnOff,UINT16 u1Thr_y,UINT16 u1Thr_c,UINT16 u1RelThr_y,UINT16 u1RelThr_c);
void vDrvMJCPreSetultra(UINT8 u1UltOnOff,UINT16 u1Thr_y,UINT16 u1Thr_c,UINT16 u1RelThr_y,UINT16 u1RelThr_c);
UINT32 u32DrvMJCPreGetHCRC(void);
UINT32 u32DrvMJCPreGetVCRC(void);
void vDrvMJCPreSetInputResolution(UINT16 u2HActive,UINT16 u2Vactive,UINT16 u2HTotal,UINT16 u2VTotal);



void vDrvMJCCmqSetCTrigTarget(UINT32 u4Target);
void vDrvMJCCmqSetFirstFrameTarget(UINT32 u4Target);
void vDrvMJCCmqSetCqNum(UINT8 u1Num);
void vDrvMJCCmqSetCqTotalNum(UINT8 u1TNum);
void vDrvMJCCmqSetCqInitNum(UINT8 u1INum);
void vDrvMJCCmqSetCqStart(UINT8 u1OnOff);
void vDrvMJCCmqSetCqMuxSel(UINT8 u1Sel);
void vDrvMJCCmqSetMVDramWEn(UINT8 u1OnOff);
void vDrvMJCCmqSetMVDramREn(UINT8 u1OnOff);
void vDrvMJCCmqSetDMAREn(UINT8 u1OnOff);
void vDrvMJCCmqSetFBAddr(UINT8 u1BufNum, UINT32 u4YAddr, UINT32 u4CAddr);
void vDrvMJCCmqSetMVAddr(UINT8 u1BufNum, UINT32 u4MVAddr);
void vDrvMJCCmqSetACTAddr0(UINT8 u1Yaddr0, UINT8 u1Caddr0);
void vDrvMJCCmqSetACTAddr1(UINT8 u1Yaddr1, UINT8 u1Caddr1);
void vDrvMJCCmqSetACTAddr2(UINT8 u1Yaddr2);
void vDrvMJCCmqSetPLDAddr0(UINT8 u1Yaddr0, UINT8 u1Caddr0);
void vDrvMJCCmqSetPLDAddr1(UINT8 u1Yaddr1, UINT8 u1Caddr1);
void vDrvMJCCmqSetPLDAddr2(UINT32 u1Yaddr2);
void vDrvMJCCmqSetMVBIAddr(UINT8 u1BIW, UINT8 u1BIR);
void vDrvMJCCmqSetMVCUAddr(UINT8 u1CUW, UINT8 u1CUR);
void vDrvMJCCmqSetMVPVAddr(UINT8 u1PV);
void vDrvMJCCmqSetMVTDAddr(UINT8 u1TDW, UINT8 u1TDR);
void vDrvMJCCmqSetWdmaAddr(UINT8 u1YWRNum, UINT8 u1CWRNum);
void vDrvMJCCmqSetRdmaAddr(UINT8 u1YRDNum, UINT8 u1CRDNum);
void vDrvMJCCmqSetWdmaDramEn(UINT8 u1OnOff);
void vDrvMJCCmqSetRdmaDramEn(UINT8 u1OnOff);
void vDrvMJCCmqSetSWRst(UINT8 u1OnOff);
void vDrvMJCCmqSetSWStart(UINT8 u1OnOff);
void vDrvMJCCmqSetPostStart(UINT8 u1OnOff);
void vDrvMJCCmqSetPreStart(UINT8 u1OnOff);
void vDrvMJCCmqSetMjcPMux(UINT8 u1OnOff);
void vDrvMJCCmqSetCmqPMux(UINT8 u1OnOff);
void vDrvMJCCmqSetMemcWDone(UINT8 u1OnOff);
void vDrvMJCCmqClearMemcWDone(UINT8 u1OnOff);
void vDrvMJCCmqSetMemcwErr(UINT8 u1OnOff);
void vDrvMJCCmqClearMemcWErr(UINT8 u1OnOff);
void vDrvMJCCmqSetMemcWSof(UINT8 u1OnOff);
void vDrvMJCCmqClearMemcWSof(UINT8 u1OnOff);
void vDrvMJCCmqSetMVAddrLimit(UINT32 u4Limit);
void vDrvMJCCmqSetDmaAddrLimit(UINT32 u4Limit);
void vDrvMJCCmqSetReqLimit(UINT8 u1Limit);
void vDrvMJCCmqSetDmaBurst(UINT8 u1Burst);
void vDrvMJCCoreSetRDMAReqStop(UINT8 u1OnOff);
UINT8 vDrvMJCCoreGetRDMAWaitDle(void);


UINT8 u1DrvMJCCmqGetCmqProcNum(void);
UINT8 u1DrvMJCCmqGetCmqWDMANum(void);
void  u1DrvMJCPreSetVsyncRisingISR(UINT8 u1OnOff);
UINT8 u1DrvMJCPreGetVsyncRisingISR(void);
void  u1DrvMJCPreClrVsyncRisingISR(UINT8 u1OnOff);
UINT8 u1DrvMJCCmqGetFSWDone(void);
UINT8 u1DrvMJCCmqGetCmqWDone(void);
UINT8 u1DrvMJCCmqGetCmqBusy(void);
UINT8 u1DrvMJCCmqGetMjcFDS(void);
void vDrvMJCCmqClearMjcFDS(UINT8 u1OnOff);
UINT8 u1DrvMJCCmqGetPreFDS(void);
void vDrvMJCCmqClearPreFDS(UINT8 u1OnOff);
UINT8 u1DrvMJCCmqGetPostFDS(void);
void vDrvMJCCmqClearPostFDS(UINT8 u1OnOff);
UINT8 u1DrvMJCCmqGetCWMDS(void);
void vDrvMJCCmqClearCWMDS(UINT8 u1OnOff);
UINT8 u1DrvMJCCmqGetCWMErrorS(void);
void vDrvMJCCmqClearCWMErrorS(UINT8 u1OnOff);
UINT8 u1DrvMJCCmqGetCWMSofS(void);
void vDrvMJCCmqClearCWMSofS(UINT8 u1OnOff);
UINT8 u1DrvMJCCmqSetExtraAddr(UINT8 u1ExtraNum,UINT32 u4ExtraAddr);
UINT8 u1DrvMJCCmqSetExtraData(UINT8 u1ExtraNum,UINT32 u4ExtraData);
UINT8 u1DrvMJCCmqSetExtraMask(UINT8 u1ExtraNum,UINT32 u4ExtraMask);
void vDrvMJCCmqSetCQReg2(UINT32 u4RegData);
void vDrvMJCCmqSetCQReg3(UINT32 u4RegData);
void vDrvMJCCmqSetCQReg4(UINT32 u4RegData);
void vDrvMJCCmqSetCQReg5(UINT32 u4RegData);
void vDrvMJCCmqSetCQReg6(UINT32 u4RegData);
void vDrvMJCCmqSet4k120Mode(UINT8 u1OnOff);
void vDrvMJCCmqUpdateSel(UINT8 u1WDMA,UINT8 u1RDMA);




void vDrvMJCPostSetBurstType(UINT8 u1BurstType);
void vDrvMJCPostSet10BitMode(UINT8 u1BitMode);
void vDrvMJCSetPostLastTotal(UINT16 u4lastTotal);
void vDrvMJCPostSetYUVTORGB(UINT8 u1OnOff);
void vDrvMJCPostSetDramEN (UINT8 u1DramOnOff);
UINT8 u1DrvMJCPostGetDramEN (void);
void vDrvMJCPostSelectDramAddr(UINT8 u1flg);
void vDrvMJCPostSetDramAddr(UINT32 u4Yaddr,UINT32 u4Caddr);
void vDrvMJCPostSetDispVPOS(UINT32 u4VPOSData);
void vDrvMJCPostSetVBP(UINT32 u4BPData);
void vDrvMJCPostSetVFP(UINT32 u4FPData);
void vDrvMJCPostSetSWReset(UINT8 u1Mode);
void vDrvMJCPostSetVsyncDLY(UINT8 u1Delay);
void vDrvMJCPostSetDramUltraEN(UINT8 u1OnOff);
void vDrvMJCPostSetDramUltraTHR(UINT32 u4Y, UINT32 u4C);
void vDrvMJCPostSet420To444(UINT8 u1OnOff);
void vDrvMJCPostSet420To422(UINT8 u1OnOff);
void vDrvMJCPostSet422To444(UINT8 u1OnOff);
void vDrvMJCPostSetMute(UINT8 u1OnOff);
void vDrvMJCPostSetMuteColor(UINT32 u4R, UINT32 u4G, UINT32 u4B);
void vDrvMJCPostSetDumpRGBPos(UINT8 u1DumpPos, UINT32 u4XPos, UINT32 u4YPos);
UINT32 u4DrvMJCPostDumpR(void);
UINT32 u4DrvMJCPostDumpG(void);
UINT32 u4DrvMJCPostDumpB(void);
UINT8 u1DrvMJCPostGetIODEStatus(void);
void vDrvMJCPostCLearFIFOStatus( UINT8 u1OnOff);
void vDrvMJCPostSetVtotal(UINT16 u2Vtotal);
void vDrvMJCPostSet4k120Mode(UINT8 u1OnOff);
void vDrvMJCPostSet420To422SramDepth(UINT16 u2SrmDepth);
void vDrvMJCPostSetBypassPostTimgen(UINT8 u1OnOff);
void vDrvMJCPostSetOne2Two(UINT8 u1Input4K);
void vDrvMJCPostSetOutputResolution(UINT16 u2HActive,UINT16 u2Vactive,UINT16 u2HTotal,UINT16 u2VTotal);
void vDrvMJCPostSetInputSel(UINT8 u1bypass);
void vDrvMJCPost420To444Inv(UINT8 u1Inv);
void vDrvMJCPostSetVPorch(void);
void vDrvMJCPostSetVsyncLine(UINT8 u1Start,UINT16 u1End);
void vDrvMJCPostSetSetdataVSampleSel(UINT8 u1Sel);
void vDrvMJCPostSetSetdataFrmDly(UINT8 u1FrmDly);
void vDrvMJCPostSetSetdataLineDly(UINT8 u1LineDly);
void vDrvMJCPostSetVCRC(UINT8 u1OnOff);
UINT32 u32DrvMJCPostGetVCH1CRC(void);
UINT32 u32DrvMJCPostGetVCH2CRC(void);


void vDrvMJCCoreSetVsearchMode(UINT8 u1Mode);
void vDrvMJCCoreSetBlockMode(UINT8 u1Mode);
void vDrvMJCCoreSetWidthHeight(UINT32 u4W, UINT32 u4H);
void vDrvMJCCoreSetSWReset(UINT32 u4Mode);
void vDrvMJCSetCoreReset(UINT8 u1OnOff);
void vDrvMJCCoreSetISRClr(UINT32 u4Clear);
void vDrvMJCCoreSetISRMask(UINT32 u4Mask);
void vDrvMJCCoreSetClrMode(UINT8 u1Mode);
void vDrvMJCCoreSetInitLoadEN(UINT8 u1OnOff);
void vDrvMJCCoreSetInitLoadMode(UINT8 u1mode);
void vDrvMJCCoreSetPreloadEN(UINT8 u1OnOff);
void vDrvMJCCoreSetPreloadMode(UINT8 u1Mode);
void vDrvMJCCoreSetMVReadEN(UINT8 u1OnOff);
void vDrvMJCCoreSetMVWriteEN(UINT8 u1OnOff);
void vDrvMJCCoreSetDmaReadEN(UINT8 u1OnOff);
void vDrvMJCCoreSetMVBIAddr(UINT32 u4WT, UINT32 u4RD);
void vDrvMJCCoreSetMVCUAddr(UINT32 u4WT, UINT32 u4RD);
void vDrvMJCCoreSetMVTDAddr(UINT32 u4WT, UINT32 u4RD);
void vDrvMJCCoreSetMVPVAddr(UINT32 u4RD);
void vDrvMJCCoreSetACTAddr0(UINT32 u4Yaddr0, UINT32 u4Caddr0, UINT32 u4Vaddr0);
void vDrvMJCCoreSetACTAddr1(UINT32 u4Yaddr1, UINT32 u4Caddr1, UINT32 u4Vaddr1);
void vDrvMJCCoreSetACTAddr2(UINT32 u4Yaddr2);
void vDrvMJCCoreSetPLDAddr0(UINT32 u4Yaddr0, UINT32 u4Caddr0, UINT32 u4Vaddr0);
void vDrvMJCCoreSetPLDAddr1(UINT32 u4Yaddr1, UINT32 u4Caddr1, UINT32 u4Vaddr1);
void vDrvMJCCoreSetPLDAddr2(UINT32 u4Yaddr2);
void vDrvMJCCoreSetRdmaPitch(UINT32 u4BlkPitch, UINT32 u4YPitch, UINT32 u4CbPitch, UINT32 u4CrPitch);
void vDrvMJCCoreSetWdmaPitch(UINT32 u4FramePitch);
void vDrvMJCCoreSetMC2XMode(UINT8 u1OnOff);
void vDrvMJCCoreSetActFlimMode(UINT8 u1OnOff);
void vDrvMJCCoreSetMeEn(UINT8 u1ME2, UINT8 u1ME3);
void vDrvMJCCoreSetActRescanEn(UINT8 u1OnOff);
void vDrvMJCCoreSetPldRescanEn(UINT8 u1OnOff);
void vDrvMJCCoreSetActMEOnlyFrm(UINT8 u1OnOff);
void vDrvMJCCoreSetPldMEOnlyFrm(UINT8 u1OnOff);
void vDrvMJCCoreSetME2PairFirst(UINT8 u1OnOff);
void vDrvMJCCoreSetBGMVKeep(UINT8 u1OnOff);
void vDrvMJCCoreSetActMEOnlyFrm(UINT8 u1OnOff);
void vDrvMJCCoreSetME2PairFirst(UINT8 u1OnOff);
void vDrvMJCCoreSetBGMVKeep(UINT8 u1OnOff);
void vDrvMJCCoreSetMVRdZero(UINT8 u1PvOn, UINT8 u1CuOn, UINT8 u1BiOn, UINT8 u1TdOn);
void vDrvMJCCoreSetSeq1stFrm(UINT8 u1OnOff);
void vDrvMJCCoreSetActPbnd(UINT32 u4rt, UINT32 u4dn);
void vDrvMJCCoreSetActLpb(UINT32 u4rt, UINT32 u4dn);
void vDrvMJCCoreSetIntpDen(UINT8 u1Den);
void vDrvMJCCoreSetMCOriEn(UINT8 u1En);
void vDrvMJCCoreSetActPairFirst(UINT8 u1OnOff);
void vDrvMJCSetOutputPattern(UINT8 u1OnOff, UINT8 u1Mode, UINT8 u1FreeRun);
void vDrvMJCSetInputPattern(UINT8 u1OnOff, UINT8 u1Mode, UINT8 u1FreeRun);
void vDrvMJCCoreSet10Bit(UINT8 u1BitMode);
void vDrvMJCCoreResetRDMA(UINT8 u1OnOff);
void vDrvMJCCoreSetClock(UINT8 u1Clock);
void vDrvMJCPowerOnOff(UINT8 u1OnOff);
void vDrvMJCPostSetLarbSel(UINT8 u1LarbSel);
void vDrvMJCPostSetPreultra(UINT8 u1PreUltOnOff,UINT16 u1Thr_y,UINT16 u1Thr_c,UINT16 u1RelThr_y,UINT16 u1RelThr_c);
void vDrvMJCPostSetultra(UINT8 u1UltOnOff,UINT16 u1Thr_y,UINT16 u1Thr_c,UINT16 u1RelThr_y,UINT16 u1RelThr_c);
void vDrvMJCWriteFldAlign(UINT32 u4Addr,UINT32 u4Val,UINT32 u4Msk);
void vDrvMJCCoreSetMEMCRdWr(UINT8 u1OnOff);

/*====================End  Function Members =======================*/

#endif
