/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

#ifndef _HW_HDR_H_
#define _HW_HDR_H_
#define IO_HDR_BASE (IO_VIRT + 0x23000)
#endif

#ifndef _HW_TECHNICOLOR_HDR_H_
#define _HW_TECHNICOLOR_HDR_H_
#define IO_TECH_HDR_BASE (IO_VIRT + 0x23000)
#endif

#ifndef _HW_PREDOWN_H_
#define _HW_PREDOWN_H_

#include "x_hal_5381.h"

#define IO_PRE_DS_BASE  (IO_VIRT+ 0x23000)


//Page PREDSMAIN
#define PRE_DS_MAIN_00 (IO_PRE_DS_BASE + 0x150)
    #define PRE_DS_MAIN_00_PRE_DSCALE_H_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_00_PRE_DSCALER_V_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_01 (IO_PRE_DS_BASE + 0x154)
    #define PRE_DS_MAIN_01_PRE_DSCALE_H_INIT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_01_PRE_DSCALE_V_INIT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_02 (IO_PRE_DS_BASE + 0x158)
    #define PRE_DS_MAIN_02_PRE_DSCALE_H_INIT_RIGHT_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_02_PRE_DSCALE_V_INIT_RIGHT_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_03 (IO_PRE_DS_BASE + 0x15C)
    #define PRE_DS_MAIN_03_PREDS_MAIN_OUT_H Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_03_PREDS_MAIN_OUT_V Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_04 (IO_PRE_DS_BASE + 0x160)
    #define PRE_DS_MAIN_04_PREDS_MAIN_IN_H Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_04_PREDS_MAIN_IN_V Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_05 (IO_PRE_DS_BASE + 0x164)
    #define PRE_DS_MAIN_05_PREDSMAIN_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define PRE_DS_MAIN_05_PREDSMAIN_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define PRE_DS_MAIN_05_MAIN_SET_RES_CLEAR_O Fld(1,27,AC_MSKB3)//[27:27]
    #define PRE_DS_MAIN_05_MAIN_SET_RES_CLEAR_I Fld(1,26,AC_MSKB3)//[26:26]
    #define PRE_DS_MAIN_05_MAIN_SET_RES_FINISH_O Fld(1,25,AC_MSKB3)//[25:25]
    #define PRE_DS_MAIN_05_MAIN_SET_RES_FINISH_I Fld(1,24,AC_MSKB3)//[24:24]
    #define PRE_DS_MAIN_05_MAIN_SETRES_ACT_LINE Fld(8,16,AC_FULLB2)//[23:16]
    #define PRE_DS_MAIN_05_MAIN_SEL_HVCNT Fld(1,15,AC_MSKB1)//[15:15]
    #define PRE_DS_MAIN_05_MAIN_CLR_HVCNT Fld(1,14,AC_MSKB1)//[14:14]
    #define PRE_DS_MAIN_05_MAIN_VCEN_ACT_AT_SYNC Fld(1,13,AC_MSKB1)//[13:13]
    #define PRE_DS_MAIN_05_MAIN_HCEN_ACT_AT_SYNC Fld(1,12,AC_MSKB1)//[12:12]
    #define PRE_DS_MAIN_05_PREDS_3DTV_MODE_1 Fld(4,8,AC_MSKB1)//[11:8]
    #define PRE_DS_MAIN_05_PREDS_LR_PAIR_CTRL Fld(2,6,AC_MSKB0)//[7:6]
    #define PRE_DS_MAIN_05_PREDS_3DTV_INV Fld(1,5,AC_MSKB0)//[5:5]
    #define PRE_DS_MAIN_05_PREDS_MAIN_SETRES Fld(1,4,AC_MSKB0)//[4:4]
    #define PRE_DS_MAIN_05_PREDS_MAIN_SETRES_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define PRE_DS_MAIN_05_PRE_DSCALE_H_BYPASS_1 Fld(1,1,AC_MSKB0)//[1:1]
    #define PRE_DS_MAIN_05_PRE_DSCALE_V_BYPASS_1 Fld(1,0,AC_MSKB0)//[0:0]
#define PRE_DS_MAIN_06 (IO_PRE_DS_BASE + 0x168)
    #define PRE_DS_MAIN_06_MAIN_H_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_06_MAIN_H_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_07 (IO_PRE_DS_BASE + 0x16C)
    #define PRE_DS_MAIN_07_MAIN_V_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_07_MAIN_V_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_08 (IO_PRE_DS_BASE + 0x170)
    #define PRE_DS_MAIN_08_PRE_DSCALE_V_INIT_BTM_1 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_MAIN_08_PRE_DSCALE_V_INIT_RIGHT_BTM_1 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_MAIN_09 (IO_PRE_DS_BASE + 0x174)
    #define PRE_DS_MAIN_09_PREDS_3D_FIELD_EN_1 Fld(1,31,AC_MSKB3)//[31:31]
    #define PRE_DS_MAIN_09_PREDS_3D_FIELD_INV_1 Fld(1,30,AC_MSKB3)//[30:30]
#define PRE_DS_MAIN_0A (IO_PRE_DS_BASE + 0x178)
    #define PRE_DS_MAIN_0A_PREDS_H_PHASE_INIT_SIGN_1 Fld(1,31,AC_MSKB3)//[31:31]
    #define PRE_DS_MAIN_0A_PREDS_H_PHASE_INIT_INTG_1 Fld(3,28,AC_MSKB3)//[30:28]
    #define PRE_DS_MAIN_0A_PREDS_H_PHASE_INIT_FRAC_1 Fld(20,8,AC_MSKDW)//[27:8]
#define PRE_DS_MAIN_0B (IO_PRE_DS_BASE + 0x17C)
    #define PRE_DS_MAIN_0B_PREDS_H_PHASE_DELTA_INTG_1 Fld(3,28,AC_MSKB3)//[30:28]
    #define PRE_DS_MAIN_0B_PREDS_H_PHASE_DELTA_FRAC_1 Fld(20,8,AC_MSKDW)//[27:8]
    #define PRE_DS_MAIN_0B_PREDS_FIR_EN Fld(1,7,AC_MSKB0)//[7:7]
    #define PRE_DS_MAIN_0B_PREDS_FIR_DLY_SEL Fld(4,3,AC_MSKB0)//[6:3]
    #define PRE_DS_MAIN_0B_PREDS_FIR_INPUT_DLY_SEL Fld(1,1,AC_MSKB0)//[1:1]


//Page PREDSPIP
#define PRE_DS_PIP_00 (IO_PRE_DS_BASE + 0x350)
    #define PRE_DS_PIP_00_PRE_DSCALE_H_2 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_PIP_00_PRE_DSCALER_V_2 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_PIP_01 (IO_PRE_DS_BASE + 0x354)
    #define PRE_DS_PIP_01_PRE_DSCALE_H_INIT_2 Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_PIP_01_PRE_DSCALE_V_INIT_2 Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_PIP_02 (IO_PRE_DS_BASE + 0x358)
    #define PRE_DS_PIP_02_PREDS_PIP_OUT_H Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_PIP_02_PREDS_PIP_OUT_V Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_PIP_03 (IO_PRE_DS_BASE + 0x35C)
    #define PRE_DS_PIP_03_PREDS_PIP_IN_H Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_PIP_03_PREDS_PIP_IN_V Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_PIP_04 (IO_PRE_DS_BASE + 0x360)
    #define PRE_DS_PIP_04_PREDSPIP_ATPG_CT Fld(1,31,AC_MSKB3)//[31:31]
    #define PRE_DS_PIP_04_PREDSPIP_ATPG_OB Fld(1,30,AC_MSKB3)//[30:30]
    #define PRE_DS_PIP_04_PIP_SET_RES_CLEAR_O Fld(1,27,AC_MSKB3)//[27:27]
    #define PRE_DS_PIP_04_PIP_SET_RES_CLEAR_I Fld(1,26,AC_MSKB3)//[26:26]
    #define PRE_DS_PIP_04_PIP_SET_RES_FINISH_O Fld(1,25,AC_MSKB3)//[25:25]
    #define PRE_DS_PIP_04_PIP_SET_RES_FINISH_I Fld(1,24,AC_MSKB3)//[24:24]
    #define PRE_DS_PIP_04_PIP_SETRES_ACT_LINE Fld(8,16,AC_FULLB2)//[23:16]
    #define PRE_DS_PIP_04_PIP_SEL_HVCNT Fld(1,15,AC_MSKB1)//[15:15]
    #define PRE_DS_PIP_04_PIP_CLR_HVCNT Fld(1,14,AC_MSKB1)//[14:14]
    #define PRE_DS_PIP_04_PIP_VCEN_ACT_AT_SYNC Fld(1,13,AC_MSKB1)//[13:13]
    #define PRE_DS_PIP_04_PIP_HCEN_ACT_AT_SYNC Fld(1,12,AC_MSKB1)//[12:12]
    #define PRE_DS_PIP_04_PREDS_PIP_SETRES Fld(1,4,AC_MSKB0)//[4:4]
    #define PRE_DS_PIP_04_PREDS_PIP_SETRES_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define PRE_DS_PIP_04_PRE_DSCALE_H_BYPASS_2 Fld(1,1,AC_MSKB0)//[1:1]
    #define PRE_DS_PIP_04_PRE_DSCALE_V_BYPASS_2 Fld(1,0,AC_MSKB0)//[0:0]
#define PRE_DS_PIP_06 (IO_PRE_DS_BASE + 0x368)
    #define PRE_DS_PIP_06_PIP_H_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_PIP_06_PIP_H_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_PIP_07 (IO_PRE_DS_BASE + 0x36C)
    #define PRE_DS_PIP_07_PIP_V_ACTIVE Fld(16,16,AC_FULLW32)//[31:16]
    #define PRE_DS_PIP_07_PIP_V_TOTAL Fld(16,0,AC_FULLW10)//[15:0]
#define PRE_DS_PIP_08 (IO_PRE_DS_BASE + 0x370)
    #define PRE_DS_PIP_08_PRE_DSCALE_V_INIT_BTM_2 Fld(16,16,AC_FULLW32)//[31:16]
#define PRE_DS_PIP_09 (IO_PRE_DS_BASE + 0x374)
    #define PRE_DS_PIP_09_PREDS_3D_FIELD_EN_2 Fld(1,31,AC_MSKB3)//[31:31]
    #define PRE_DS_PIP_09_PREDS_3D_FIELD_INV_2 Fld(1,30,AC_MSKB3)//[30:30]
    #define PRE_DS_PIP_09_PREDS_PIP_10BIT_BYPASS Fld(1,29,AC_MSKB3)//[29:29]   //gazelle only
//Page HDR2SDR
#define PNSC_CTRL_0 (IO_HDR_BASE + 0xCF8)
	#define C_HDR2SDR_MAIN_BYPASS_1 Fld(1,18,AC_MSKB2)//[18:18]
	#define C_HDR2SDR_MAIN_BYPASS_0 Fld(1,17,AC_MSKB2)//[17:17]
	#define HDR_FIFO_RESET Fld(1,16,AC_MSKB2)//[16:16]
    #define C_PNSC_HDR_P_SRC_SWITCH Fld(3,13,AC_MSKB1)//[15:13]
    #define C_PNSC_HDR_M_SRC_SWITCH Fld(3,10,AC_MSKB1)//[12:10]
    #define C_PNSC_HDR_SUB_SRC_SEL Fld(1,9,AC_MSKB1)//[9:9]
    #define C_PNSC_HDR_MAIN_SRC_SEL Fld(1,8,AC_MSKB1)//[8:8]
    #define C_PNSC_HDR_SUB_CEN_SEL Fld(1,7,AC_MSKB0)//[7:7]
    #define C_PNSC_HDR_MAIN_CEN_SEL Fld(1,6,AC_MSKB0)//[6:6]
    #define C_PNSC_HDR_SUB_BYPASS Fld(1,5,AC_MSKB0)//[5:5]
    #define C_FSAMPLE_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR2SDR_ATPG (IO_HDR_BASE + 0xCFC)
    #define HDR2SDR_ATPG_OB Fld(1,1,AC_MSKB0)//[1:1]
    #define HDR2SDR_ATPG_CT Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_TOP (IO_HDR_BASE + 0xC04)
    #define HDR_ATPG_OB Fld(1,31,AC_MSKB3)//[31:31]
    #define HDR_ATPG_CT Fld(1,30,AC_MSKB3)//[30:30]
    #define BT2020_CONST_LUMA Fld(1,17,AC_MSKB2)//[17:17]
    #define DBUF_READ_WRK Fld(1,15,AC_MSKB1)//[15:15]
    #define DBUF_PROTECT Fld(1,14,AC_MSKB1)//[14:14]
    #define DBUF_EN Fld(1,13,AC_MSKB1)//[13:13]
    #define SDR_GAMMA Fld(1,12,AC_MSKB1)//[12:12]
    #define HDR_INK_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define INK_SEL Fld(2,8,AC_MSKB1)//[9:8]
    #define DCM_DIS Fld(1,3,AC_MSKB0)//[3:3]
    #define HDR_RESET Fld(1,2,AC_MSKB0)//[2:2]
    #define BT2020_IN Fld(1,1,AC_MSKB0)//[1:1]
    #define HDR_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_INTERR (IO_HDR_BASE + 0xC08)
    #define INT_BOX_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define INT_HIST_EN Fld(1,2,AC_MSKB0)//[2:2]
    #define INT_OF_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define INT_IF_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_INTSTA (IO_HDR_BASE + 0xC0C)
    #define INT_BOX_END Fld(1,3,AC_MSKB0)//[3:3]
    #define INT_HIST_END Fld(1,2,AC_MSKB0)//[2:2]
    #define INT_OF_END Fld(1,1,AC_MSKB0)//[1:1]
    #define INT_IF_END Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_ENGSTA (IO_HDR_BASE + 0xC10)
    #define STA_CSR_UNF Fld(1,2,AC_MSKB0)//[2:2]
    #define STA_OF_UNF Fld(1,1,AC_MSKB0)//[1:1]
    #define STA_IF_UNF Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_SIZE_0 (IO_HDR_BASE + 0xC14)
    #define IN_VSIZE Fld(13,16,AC_MSKW32)//[28:16]
    #define IN_HSIZE Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_HIST_CTRL_0 (IO_HDR_BASE + 0xC20)
    #define HIST_BEGIN_Y Fld(13,16,AC_MSKW32)//[28:16]
    #define HIST_BEGIN_X Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_HIST_CTRL_1 (IO_HDR_BASE + 0xC24)
    #define HIST_END_Y Fld(13,16,AC_MSKW32)//[28:16]
    #define HIST_END_X Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_DEMO_CTRL_0 (IO_HDR_BASE + 0xC28)
    #define DEMO_BEGIN_Y Fld(13,16,AC_MSKW32)//[28:16]
    #define DEMO_BEGIN_X Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_DEMO_CTRL_1 (IO_HDR_BASE + 0xC2C)
    #define HDR_DEMO_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define DEMO_SEL Fld(1,30,AC_MSKB3)//[30:30]
    #define DEMO_END_Y Fld(13,16,AC_MSKW32)//[28:16]
    #define DEMO_END_X Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_3X3_COEF_0 (IO_HDR_BASE + 0xC30)
    #define GAMUT_ROUND_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define GAMUT_MATRIX_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_3X3_COEF_1 (IO_HDR_BASE + 0xC34)
    #define C01 Fld(16,16,AC_FULLW32)//[31:16]
    #define C00 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_3X3_COEF_2 (IO_HDR_BASE + 0xC38)
    #define C10 Fld(16,16,AC_FULLW32)//[31:16]
    #define C02 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_3X3_COEF_3 (IO_HDR_BASE + 0xC3C)
    #define C12 Fld(16,16,AC_FULLW32)//[31:16]
    #define C11 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_3X3_COEF_4 (IO_HDR_BASE + 0xC40)
    #define C21 Fld(16,16,AC_FULLW32)//[31:16]
    #define C20 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_3X3_COEF_5 (IO_HDR_BASE + 0xC44)
    #define C22 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_3X3_COEF_6 (IO_HDR_BASE + 0xC48)
    #define PRE_ADD_0 Fld(17,0,AC_MSKDW)//[16:0]
#define HDR_3X3_COEF_7 (IO_HDR_BASE + 0xC4C)
    #define PRE_ADD_1 Fld(17,0,AC_MSKDW)//[16:0]
#define HDR_3X3_COEF_8 (IO_HDR_BASE + 0xC50)
    #define PRE_ADD_2 Fld(17,0,AC_MSKDW)//[16:0]
#define HDR_3X3_COEF_9 (IO_PIO_HDR_BASERE_DS_BASE + 0xC54)
    #define POST_ADD_0 Fld(17,0,AC_MSKDW)//[16:0]
#define HDR_3X3_COEF_10 (IO_HDR_BASE + 0xC58)
    #define POST_ADD_1 Fld(17,0,AC_MSKDW)//[16:0]
#define HDR_3X3_COEF_11 (IO_HDR_BASE + 0xC5C)
    #define POST_ADD_2 Fld(17,0,AC_MSKDW)//[16:0]
#define HDR_TONE_MAP_P12 (IO_HDR_BASE + 0xC60)
    #define REG_P2 Fld(16,16,AC_FULLW32)//[31:16]
    #define REG_P1 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_TONE_MAP_P34 (IO_HDR_BASE + 0xC64)
    #define REG_P4 Fld(16,16,AC_FULLW32)//[31:16]
    #define REG_P3 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_TONE_MAP_P5 (IO_HDR_BASE + 0xC68)
    #define REG_P5 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_TONE_MAP_S0 (IO_HDR_BASE + 0xC6C)
    #define REG_SLOPE0 Fld(19,0,AC_MSKDW)//[18:0]
#define HDR_TONE_MAP_S1 (IO_HDR_BASE + 0xC70)
    #define REG_SLOPE1 Fld(19,0,AC_MSKDW)//[18:0]
#define HDR_TONE_MAP_S2 (IO_HDR_BASE + 0xC74)
    #define REG_SLOPE2 Fld(19,0,AC_MSKDW)//[18:0]
#define HDR_TONE_MAP_S3 (IO_HDR_BASE+ 0xC78)
    #define REG_SLOPE3 Fld(19,0,AC_MSKDW)//[18:0]
#define HDR_TONE_MAP_S4 (IO_HDR_BASE + 0xC7C)
    #define REG_SLOPE4 Fld(19,0,AC_MSKDW)//[18:0]
#define HDR_B_CHANNEL_NR (IO_HDR_BASE + 0xC80)
    #define REG_NR_STRENGTH Fld(4,4,AC_MSKB0)//[7:4]
    #define REG_FILTER_NO Fld(1,1,AC_MSKB0)//[1:1]
    #define REG_NR_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_HIST_ADDR (IO_HDR_BASE + 0xC84)
    #define HIST_PING_PONG_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define HIST_MSB_SHIFT_VALID Fld(1,29,AC_MSKB3)//[29:29]
    #define HIST_MSB_SHIFT Fld(5,24,AC_MSKB3)//[28:24]
    #define LAST_NON_ZERO_BIN Fld(6,16,AC_MSKB2)//[21:16]
    #define HIST_READ_FULL Fld(1,13,AC_MSKB1)//[13:13]
    #define HIST_ADDR_AUTO_INC_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define HIST_ADDR_AUTO_INC_RW Fld(1,10,AC_MSKB1)//[10:10]
    #define HIST_CLR_EN Fld(1,9,AC_MSKB1)//[9:9]
    #define REG_HIST_EN Fld(1,8,AC_MSKB1)//[8:8]
    #define HIST_ADDR Fld(6,0,AC_MSKB0)//[5:0]
#define HDR_HIST_DATA (IO_HDR_BASE + 0xC88)
    #define HIST_DATA Fld(32,0,AC_FULLDW)//[31:0]
#define HDR_A_LUMINANCE (IO_HDR_BASE + 0xC8C)
    #define REG_MAXRGB_WEIGHT Fld(4,4,AC_MSKB0)//[7:4]
    #define REG_LUMA_GAIN_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_GAIN_TABLE_0 (IO_HDR_BASE + 0xC90)
    #define GAIN_TABLE_PING_PONG_EN Fld(1,31,AC_MSKB3)//[31:31]
    #define GAIN_TABLE_STATUS Fld(1,14,AC_MSKB1)//[14:14]
    #define GAIN_TABLE_ODD_WEN Fld(1,13,AC_MSKB1)//[13:13]
    #define GAIN_TABLE_EVEN_WEN Fld(1,12,AC_MSKB1)//[12:12]
    #define GAIN_TABLE_ADDR_AUTO_INC_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define GAIN_TABLE_ADDR_AUTO_INC_RW Fld(1,10,AC_MSKB1)//[10:10]
    #define GAIN_TABLE_UPDATE Fld(1,8,AC_MSKB1)//[8:8]
    #define GAIN_TABLE_ADDR Fld(7,0,AC_MSKB0)//[6:0]
#define HDR_GAIN_TABLE_1 (IO_HDR_BASE + 0xC94)
    #define GAIN_TABLE_DATA Fld(32,0,AC_FULLDW)//[31:0]
#define HDR_Y2R_R2Y (IO_HDR_BASE + 0xC98)
    #define Y2R_ROUND_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define R2Y_ROUND_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_LBOX_DET_1 (IO_HDR_BASE + 0xC9C)
    #define RT_SKIP Fld(8,24,AC_FULLB3)//[31:24]
    #define LF_SKIP Fld(8,16,AC_FULLB2)//[23:16]
    #define BLACK_Y_LEVEL Fld(8,8,AC_FULLB1)//[15:8]
    #define OUTPUT_OFFSET Fld(4,4,AC_MSKB0)//[7:4]
    #define LBOX_DET_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_LBOX_DET_2 (IO_HDR_BASE + 0xCA0)
    #define START_DET_POS Fld(8,0,AC_FULLB0)//[7:0]
#define HDR_LBOX_DET_3 (IO_HDR_BASE + 0xCA4)
    #define DNPOS Fld(13,16,AC_MSKW32)//[28:16]
    #define UPPOS Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_CURSOR_CTRL (IO_HDR_BASE + 0xCA8)
    #define CURSOR_SEL Fld(4,4,AC_MSKB0)//[7:4]
    #define CURSOR_EN Fld(1,0,AC_MSKB0)//[0:0]
#define HDR_CURSOR_POS (IO_HDR_BASE + 0xCAC)
    #define CURSOR_TARGV Fld(13,16,AC_MSKW32)//[28:16]
    #define CURSOR_TARGH Fld(13,0,AC_MSKW10)//[12:0]
#define HDR_CURSOR_COLOR (IO_HDR_BASE + 0xCB0)
    #define CURSOR_CR Fld(4,8,AC_MSKB1)//[11:8]
    #define CURSOR_CB Fld(4,4,AC_MSKB0)//[7:4]
    #define CURSOR_Y Fld(4,0,AC_MSKB0)//[3:0]
#define HDR_CURSOR_BUF0 (IO_HDR_BASE + 0xCB8)
    #define CURSOR_BUFFER1 Fld(16,16,AC_FULLW32)//[31:16]
    #define CURSOR_BUFFER0 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_CURSOR_BUF1 (IO_HDR_BASE + 0xCBC)
    #define CURSOR_BUFFER2 Fld(16,0,AC_FULLW10)//[15:0]
#define HDR_DUMMY0 (IO_HDR_BASE + 0xCC0)
    #define HDR_DUMMY_0 Fld(32,0,AC_FULLDW)//[31:0]
#define HDR_DUMMY1 (IO_HDR_BASE + 0xCC4)
    #define HDR_DUMMY_1 Fld(32,0,AC_FULLDW)//[31:0]
#define HDR_DUMMY2 (IO_HDR_BASE + 0xCC8)
    #define HDR_DUMMY_2 Fld(32,0,AC_FULLDW)//[31:0]
#define HDR_PROG_EOTF (IO_HDR_BASE + 0xCCC)
    #define LAST_EOTF_POS Fld(11,21,AC_MSKW32)//[31:21]
    #define LAST_EOTF_ELEMENT Fld(17,0,AC_MSKDW)//[16:0]
#define HDR_EOTF_TABLE_0 (IO_HDR_BASE + 0xCD0)
    #define EOTF_TABLE_ODD_WEN Fld(1,13,AC_MSKB1)//[13:13]
    #define EOTF_TABLE_EVEN_WEN Fld(1,12,AC_MSKB1)//[12:12]
    #define EOTF_TABLE_ADDR_AUTO_INC_EN Fld(1,11,AC_MSKB1)//[11:11]
    #define EOTF_TABLE_ADDR_AUTO_INC_RW Fld(1,10,AC_MSKB1)//[10:10]
    #define EOTF_TABLE_ADDR Fld(9,0,AC_MSKW10)//[8:0]
#define HDR_EOTF_TABLE_1 (IO_HDR_BASE + 0xCD4)
    #define EOTF_TABLE_DATA Fld(32,0,AC_FULLDW)//[31:0]

//Page TECHNICOLOR_HDR
#define TECH_HDR_00 (IO_TECH_HDR_BASE + 0xB00)
    #define FORCE_SRAM_CS_ON Fld(1,17,AC_MSKB2)//[17:17]
    #define VA_READ_LATEST_WDATA Fld(1,16,AC_MSKB2)//[16:16]
    #define RDATA_BYTE_EN_SEL Fld(2,14,AC_MSKB1)//[15:14]
    #define WDATA_BYTE_EN_SEL Fld(2,12,AC_MSKB1)//[13:12]
    #define RD_AUTO_INC_ADDR Fld(1,11,AC_MSKB1)//[11:11]
    #define WR_AUTO_INC_ADDR Fld(1,10,AC_MSKB1)//[10:10]
    #define PIO_MODE Fld(1,9,AC_MSKB1)//[9:9]
    #define FORCE_WR_NO_WAIT Fld(1,8,AC_MSKB1)//[8:8]
    #define MAX_WAIT_CYCLE Fld(8,0,AC_FULLB0)//[7:0]
#define TECH_HDR_01 (IO_TECH_HDR_BASE + 0xB04)
    #define CPURW_ACTIVE_IS Fld(1,13,AC_MSKB1)//[13:13]
    #define CPURW_ACTIVE_VPP_PN Fld(1,12,AC_MSKB1)//[12:12]
    #define CPURW_ACTIVE_PN Fld(1,11,AC_MSKB1)//[11:11]
    #define CPURW_ACTIVE_VPP_D Fld(1,10,AC_MSKB1)//[10:10]
    #define CPURW_ACTIVE_D Fld(1,9,AC_MSKB1)//[9:9]
    #define CPURW_ACTIVE_VPP_C Fld(1,8,AC_MSKB1)//[8:8]
    #define CPU_SEL_SRAM_0 Fld(1,7,AC_MSKB0)//[7:7]
    #define CPURW_ACTIVE_C Fld(1,6,AC_MSKB0)//[6:6]
    #define TABLE_WAIT_VSYNC Fld(1,5,AC_MSKB0)//[5:5]
    #define FILL_TABLE_READY Fld(1,4,AC_MSKB0)//[4:4]
    #define TECH_READ_FINISH Fld(1,3,AC_MSKB0)//[3:3]
    #define TECH_READ Fld(1,2,AC_MSKB0)//[2:2]
    #define TECH_WRITE_FINISH Fld(1,1,AC_MSKB0)//[1:1]
    #define TECH_WRITE Fld(1,0,AC_MSKB0)//[0:0]
#define TECH_HDR_02 (IO_TECH_HDR_BASE + 0xB08)
    #define TECH_COE_SEL Fld(5,24,AC_MSKB3)//[28:24]
    #define TECH_CPU_SRAM_ADDR Fld(12,12,AC_MSKW21)//[23:12]
    #define TECH_R_ADDR Fld(12,0,AC_MSKW10)//[11:0]
#define TECH_HDR_03 (IO_TECH_HDR_BASE + 0xB0C)
    #define WDATA_00 Fld(32,0,AC_FULLDW)//[31:0]
#define TECH_HDR_04 (IO_TECH_HDR_BASE + 0xB10)
    #define RDATA_00 Fld(32,0,AC_FULLDW)//[31:0]
#define TECH_HDR_05 (IO_TECH_HDR_BASE + 0xB14)
    #define HDR_COEF_PP_RD_PN Fld(1,3,AC_MSKB0)//[3:3]
    #define HDR_COEF_PP_RD_D Fld(1,2,AC_MSKB0)//[2:2]
    #define HDR_COEF_PP_RD_C Fld(1,1,AC_MSKB0)//[1:1]
    #define HDR_COEF_PP_WRT_A Fld(1,0,AC_MSKB0)//[0:0]
#define TECH_HDR_06 (IO_TECH_HDR_BASE + 0xB18)
    #define COLOR_SPACE Fld(2,28,AC_MSKB3)//[29:28]
    #define HDR_CONTAINER Fld(1,27,AC_MSKB3)//[27:27]
    #define YUV_RANGE Fld(1,26,AC_MSKB3)//[26:26]
    #define ALPHA_B Fld(13,13,AC_MSKDW)//[25:13]
    #define ALPHA_A Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_07 (IO_TECH_HDR_BASE + 0xB1C)
    #define OCT2 Fld(10,20,AC_MSKW32)//[29:20]
    #define OCT1 Fld(10,10,AC_MSKW21)//[19:10]
    #define OCT0 Fld(10,0,AC_MSKW10)//[9:0]
#define TECH_HDR_08 (IO_TECH_HDR_BASE + 0xB20)
    #define OCT5 Fld(10,20,AC_MSKW32)//[29:20]
    #define OCT4 Fld(10,10,AC_MSKW21)//[19:10]
    #define OCT3 Fld(10,0,AC_MSKW10)//[9:0]
#define TECH_HDR_09 (IO_TECH_HDR_BASE + 0xB24)
    #define BA Fld(11,16,AC_MSKW32)//[26:16]
    #define OCT6 Fld(10,0,AC_MSKW10)//[9:0]
#define TECH_HDR_10 (IO_TECH_HDR_BASE + 0xB28)
    #define D_THRESHOLD1 Fld(13,16,AC_MSKW32)//[28:16]
    #define D_THRESHOLD0 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_11 (IO_TECH_HDR_BASE + 0xB2C)
    #define D_STEP3 Fld(4,28,AC_MSKB3)//[31:28]
    #define D_STEP2 Fld(4,24,AC_MSKB3)//[27:24]
    #define D_STEP1 Fld(4,20,AC_MSKB2)//[23:20]
    #define D_STEP0 Fld(4,16,AC_MSKB2)//[19:16]
    #define D_THRESHOLD2 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_12 (IO_TECH_HDR_BASE + 0xB30)
    #define O_SIGNED Fld(1,8,AC_MSKB1)//[8:8]
    #define I_SIGNED Fld(1,7,AC_MSKB0)//[7:7]
    #define EXT_TABLE_EN Fld(1,6,AC_MSKB0)//[6:6]
    #define INT_TABLE_SEL Fld(4,2,AC_MSKB0)//[5:2]
    #define CT_BYPASS Fld(1,1,AC_MSKB0)//[1:1]
    #define CT_EN Fld(1,0,AC_MSKB0)//[0:0]
#define TECH_HDR_13 (IO_TECH_HDR_BASE + 0xB34)
    #define EXT_C01 Fld(13,16,AC_MSKW32)//[28:16]
    #define EXT_C00 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_14 (IO_TECH_HDR_BASE + 0xB38)
    #define EXT_C10 Fld(13,16,AC_MSKW32)//[28:16]
    #define EXT_C02 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_15 (IO_TECH_HDR_BASE + 0xB3C)
    #define EXT_C12 Fld(13,16,AC_MSKW32)//[28:16]
    #define EXT_C11 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_16 (IO_TECH_HDR_BASE + 0xB40)
    #define EXT_C21 Fld(13,16,AC_MSKW32)//[28:16]
    #define EXT_C20 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_17 (IO_TECH_HDR_BASE + 0xB44)
    #define EXT_C22 Fld(13,0,AC_MSKW10)//[12:0]
#define TECH_HDR_18 (IO_TECH_HDR_BASE + 0xB48)
    #define EXT_PRE_ADD_2 Fld(9,20,AC_MSKW32)//[28:20]
    #define EXT_PRE_ADD_1 Fld(9,10,AC_MSKW21)//[18:10]
    #define EXT_PRE_ADD_0 Fld(9,0,AC_MSKW10)//[8:0]
#define TECH_HDR_19 (IO_TECH_HDR_BASE + 0xB4C)
    #define EXT_POST_ADD_2 Fld(9,20,AC_MSKW32)//[28:20]
    #define EXT_POST_ADD_1 Fld(9,10,AC_MSKW21)//[18:10]
    #define EXT_POST_ADD_0 Fld(9,0,AC_MSKW10)//[8:0]
#define TECH_HDR_20 (IO_TECH_HDR_BASE + 0xB50)
    #define HDR_DB_EN Fld(1,1,AC_MSKB0)//[1:1]
    #define C_TECH_HDR_MAIN_BYPASS Fld(1,0,AC_MSKB0)//[0:0]
#define TECHNICOLOR_HDR_ATPG (IO_TECH_HDR_BASE + 0xBFC)
    #define TECHNICOLOR_HDR_ATPG_OB Fld(1,1,AC_MSKB0)//[1:1]
    #define TECHNICOLOR_HDR_ATPG_CT Fld(1,0,AC_MSKB0)//[0:0]    
#endif    
