#ifndef _DRV_DOLBY_DRVIF_H_
#define _DRV_DOLBY_DRVIF_H_

#include "x_typedef.h"
#include "x_timer.h"


#define  DOLBY_VIDEO_INFO       1
#define  DOLBY_METADATA_INFO    2
#define  MAX_GD_DEBUG_INFO_FRAME_CNT 3000


#define  DOLBY_RUN_MODE_MASK         3
    #define OTT_MODE                 (0)
    #define HDMI_HD_MODE             (1<<1)
    #define BYPASS_MODE              (1)
    #define HDMI_UHD_MODE            (3)
#define  DOLBY_Opt_MODE_MASK         (3<<2)
    #define BL_EL_RATIO11            (1<<2)
    #define BL_EL_RATIO41            (3<<2)
#define  DOLBY_GRAPHIC_MASK          (1<<5)
    #define GRAPHIC_DISABLE          (0<<5)
    #define GRAPHIC_ENABLE           (1<<5)
#define  DOLBY_PIXEL_RATE_MASK       (0xf<<6)
    #define PIXEL_RATE_23_98         (0<<6)
    #define PIXEL_RATE_24            (1<<6)
    #define PIXEL_RATE_25            (2<<6)
    #define PIXEL_RATE_29_97         (3<<6)
    #define PIXEL_RATE_30            (4<<6)
    #define PIXEL_RATE_50            (5<<6)
    #define PIXEL_RATE_59_94         (6<<6)
    #define PIXEL_RATE_60            (7<<6)
    #define PIXEL_RATE_120           (8<<6)
    
#define DOLBY_METADATA_DEBUG_OTT      0x1
#define DOLBY_METADATA_DEBUG_RPU      0x2
#define DOLBY_METADATA_DEBUG_DM_COMP  0x4
#define DOLBY_VERIFICATION            0x8
#define DOLBY_DEBUG_REG_LUT           0x10
#define DOLBY_DEBUG_CRC               0x20
#define DOLBY_DEBUG_DM_STATUS         0x40
#define DOLBY_DEBUG_GD_STATUS         0x80


//-----------------------------------------------------------------------------
// Type definitions
//-----------------------------------------------------------------------------

typedef void (*PFN_DOVI_HDR_NFY_FCT) (
    UINT32              u4CurHDR,
    UINT32              u4LastHDR
);

typedef enum _ENUM_DOVI_HDR_TYPE_T_
{
    DOVI_HDR_TYPE_SDR = 0,
    DOVI_HDR_TYPE_DV = 13,
    DOVI_HDR_TYPE_HDR10 = 16,
    DOVI_HDR_TYPE_HLG = 18,
} ENUM_DOVI_HDR_TYPE_T;


typedef struct  {
    int frame_num;
    int width ;
    int height;
    char cFileNm[128];
	char cFilePath[128];
} DOLBY_CLI_PRM_T;

/** Brief of DOLBY_MSG_T
 */

typedef struct
{
    UINT32 u4Arg1;
    UPTR   u4Arg2;
    UINT32 u4Arg3;
    UINT32 u4Arg4;
    UINT32 u4Arg5;
} DOLBY_MSG_T;

typedef struct
{
    UINT8 u1VdpId;
    UINT8 u1Dolby_Mode;
    UINT8 u1Omux_Source;
} DOLBY_SRC_T;

typedef struct 
{
    UINT32 Dolby_Out_Y_Crc;
    UINT32 Dolby_Out_U_Crc;
    UINT32 Dolby_Out_V_Crc;
    UINT32 Dolby_IN_Y_Crc;
    UINT32 Dolby_IN_U_Crc;
    UINT32 Dolby_IN_V_Crc;
    
    UINT32 LUT_3D_Crc;
    UINT32 TC_Crc;
    UINT32 DM_Crc;
    UINT32 BL_Crc;
    UINT32 EL_Crc;
    UINT32 COMP_Crc;
    UINT32 COMP_420_Crc;

    UINT32 MIB_SRCW_CRC_OUT_V;
    UINT32 MIB_OUT_CRC_OUT_V;

    UINT32 frame_nr;
    //Pre-proc CRC
    
}DOLBY_CRC_T;

typedef struct 
{
	//about source
    UINT32 u4Runmode;
    UINT32 u4Optmode;
    UINT32 u4Graphicmode;
    UINT32 u4PixelRate;
    UINT32 u4MetadataProgramErrorEnable;

    UINT32 u4DolbyMode;
    UINT32 u4Dolby_Dma_Vysnc_Mode;
    UINT32 u4Dolby_Dma_Hsync_mode;
    UINT32 u4Dolby_ClkEn;

    UINT32 u4Dolby_3D_Num;
    UINT32 u4Dolby_Tc_Num;
    UINT32 u4Dolby_3D_Addr;
    UINT32 u4Dolby_Tc_Addr;

    UINT32 u4Dolby_Sel444;
    UINT32 u4Dolby_Yc2Yuc_En;

    UINT32 u4BLWidth;
    UINT32 u4BLHeight;
	UINT32 u4InputFormat;
    UINT32 u4InputColorFmt;

	
	//about  frame status
	UINT32 rpu_ret;
    UINT32 dm_ret;
	UINT32 frame_nr;
	BOOL   src_change_flag;
}DOLBY_PRM_T;

typedef struct
{
    UINT8  u1IsDoviHDR[2]; //Main or sub
	UINT32 u4GolbalDimmingEn;
	UINT32 u4DoviFmt;
	UINT32 u4IsDtrFelMode;
	UINT32 u4IsDtrFelModeCheckDone;
	PFN_DOVI_HDR_NFY_FCT pfDOVIHDRInfoCb;
	UCHAR  ucVdpIdDolbyUse;
}DOLBY_CUSTOM_SOURCE_INFO_T;


typedef struct
{
    UINT32 u4MetadataDbgFlag;
	UINT32 u4DolbyBypassEn;
	UINT32 u4DolbyHdmiDumpDoneFlag;
	UINT32 u4dolbyScnChgEn;
	UINT32 u4ForceGDOnOff;
}DOLBY_DBG_INFO_T;

typedef struct
{
    UINT8 u1IsDoviHDR; 
}DOLBY_SOURCE_INFO_T;//used for mtal


typedef enum
{
    DOLBY_PIC_MODE_BRIGHT=0,
    DOLBY_PIC_MODE_DARK,
    DOLBY_PIC_MODE_IDK,
    DOLBY_PIC_MODE_LL,
    DOLBY_PIC_MODE_MAX
}DOLBY_PIC_MODE_T;

typedef enum 
{
    DOLBY_FORMAT_INVALID = -1,
    DOLBY_FORMAT_DOVI = 0,
    DOLBY_FORMAT_HDR10 = 1,
    DOLBY_FORMAT_SDR = 2,
    DOLBY_FORMAT_DOVI_LL = 3
} DOLBY_SRC_FMT_T; //same as cotnrol_path_api.h

typedef enum 
{
    DOLBY_INPUT_MODE_OTT = 0,
    DOLBY_INPUT_MODE_HDMI= 1
} DOLBY_RUN_MODE_t;

typedef struct
{
    BOOL pic_mode_ready_flag;
    DOLBY_PIC_MODE_T dolby_pic_mode;//used for get dolby mode indx
	UINT32 u4PreGdBacklightVal; 
	UINT32 u4GdBacklightVal;
	UINT32 u4IsDropCurFrame;
}DOLBY_DM_CUST_SET_INFO_T;

typedef struct
{
    HAL_TIME_T tGetGdFromDvTimeStap;
    UINT32  u4DvGdDuty;//used for sony 
    UINT32  u4NextDvGdDuty;//used for sony 
    UINT32  u4SourceFrameNr;//
    UINT32  u4SourceVideoInCrc;//    
    UINT32  u4DvLoopCnt;//
    UINT32  reserved1[1];//make struct size 2 pow 
	//exten  info
}DOLBY_GD_INFO_AFTER_GET_FROM_DV_T;//gd info get from dv moudle

typedef struct
{
    UINT32  u4DvGdDuty;//used for sony 
    UINT32  u4PreDvGdDuty; //output domain
    UINT32  u4NextDvGdDuty;//output domain
    UINT32  u4SourceFrameNr;//
    UINT32  u4SourceVideoInCrc;//
    UINT32  u4VdpOutputDomainFrameNr;
	BOOL    u4DvGdValid;
    HAL_TIME_T tGetGdFromDvTimeStap;
    HAL_TIME_T tGetGdFromVdpAfterVideoPmwSyncTimeStap;
	//exten  info
}DOLBY_GD_INFO_AFTER_VIDEO_PWM_SYNC_T;//gd info get from vdp after sync


typedef struct
{
	//also add dolby parser gd time and frame number push to mib isr but this need a fifo in dv moudle
    UINT32 u4VdpOutputDomainFrameNr;//input domain frame number
	UINT32 u4VideoAndDutyDelayCnt;
    UINT32 u4CurInOutGdDelayCnt;
    UINT32 u4InkOstgGValue;
	HAL_TIME_T tVdpGetDvInfoStap;
	DOLBY_GD_INFO_AFTER_GET_FROM_DV_T strVdpGetDvGdInfo;//FIFO IN
	HAL_TIME_T tVdpSetDvInfoStap;
	DOLBY_GD_INFO_AFTER_GET_FROM_DV_T strVdpSetDvGdInfo;//FIFO OUT
	HAL_TIME_T tSonyGetDvInfoStap;
    UINT32 u4SonyGetDvEn;
    UINT32 u4SonyGetDvGdEn;
    UINT32 u4SonyGetDvGdDuty;
	//exten other info
}DOLBY_GD_DBUG_INFO_T;






EXTERN DOLBY_CLI_PRM_T 				dolby_cli_param;
EXTERN DOLBY_DBG_INFO_T 			dolby_dbg_param;
EXTERN DOLBY_PRM_T 					dolbyprminfo;
EXTERN DOLBY_CRC_T 					dolbyCrcInfo;
EXTERN DOLBY_DM_CUST_SET_INFO_T     doviDMCustInfo_t;
EXTERN DOLBY_GD_INFO_AFTER_VIDEO_PWM_SYNC_T 				doviGdInfoAfterVideoPmwSnc;
EXTERN DOLBY_GD_INFO_AFTER_GET_FROM_DV_T	doviGdInfoAfterGetFromDv;
EXTERN DOLBY_GD_DBUG_INFO_T* ptr_gd_debug_info;




//used for dtv driver
EXTERN void vDolby_SendEvent(DOLBY_MSG_T tMsg);
EXTERN void vDrvDolbySetSource(DOLBY_SRC_T tSrc);
EXTERN void vDolbyMLInit(void);
EXTERN void vDolbyUninit(void);
EXTERN void vDolbyResume(void);
EXTERN void vDolbySuspend(void);
EXTERN UINT32 u4DolbyGetCustSourceInfo(UINT8 u1VdpId);
EXTERN UINT32  u4DolbyGetSourceType(void);
EXTERN UINT32 u4DolbyGetGlobalDimmingInfo(void);
EXTERN UINT32 u4DolbyGetGdPwmValue(void);
EXTERN INT32  i4DolbyGetGdPwmDelay(INT32 *ptr_gdDelayMilliSec_ott,INT32 *ptr_gdDelayMilliSec_hdmi);
EXTERN UINT32 u4DolbyGetSourceFmtInfo(void);
EXTERN UINT32 u4DolbyGetDtrFelInfo(void);
EXTERN BOOL   vDolbyRegHDRInfoCb(PFN_DOVI_HDR_NFY_FCT pfnHDRInfoCb);
EXTERN UINT32 u4DolbyGetEfuseInfo(void);
EXTERN UINT32 u4DolbyGetIdkVersion(void);
EXTERN UINT8 u4DolbyGetDoviType(void);


EXTERN DOLBY_PIC_MODE_T u4DolbyGetPicMode(void);
EXTERN void vDolbySetPicMode(DOLBY_PIC_MODE_T pic_mode);
EXTERN BOOL u1DolbyGetPicModeReadyFlag(void);

EXTERN void vDolbyUpdateVsvdb(unsigned char *pdata);
EXTERN void vDolbyUpdateVsif(unsigned char *pdata);
EXTERN void vDolbyHdmiSrcDumpCtrl(void);
EXTERN void vDolbySetConfiFile(UINT8 u1PicMode,UPTR u4addr, UINT32 u4size);
EXTERN INT32 u4DolbyGetGdPwmInfo(DOLBY_GD_INFO_AFTER_GET_FROM_DV_T* ptrGDInfoFromDv);


//used for cli
EXTERN void vDolbySetLoop(BOOL bRunLoop);
EXTERN void vDolbySetDbgFlag(UINT32 bDebugFlag);
EXTERN void vDolbyInfoQuery(void);
EXTERN void vDolbyUpdateLowLatencyModeCfg(void);
EXTERN void vDolbySetBypassFlag(UINT32 bDebugFlag);
EXTERN void vDolbyEnableScenceFlag(UINT8 u1ScnChgEn);
EXTERN void vDolbyForceGDOnOff(UINT32 bOn);
EXTERN void vDolbySetCmdLogLvl(UINT32 msk);
EXTERN void vDolbyCatDvGDInfo(UINT8 u1CatEn);

//used for mtal
EXTERN INT32 u4DolbyGetDoviHDRInfo(UCHAR ucVdpId,  void* pkvPqGetInfo, UINT32 u4Size);

#endif

