/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


#include "x_typedef.h"
#include "x_tz.h"
#include "x_bim.h"
#include "x_dram.h"
#if defined(CC_SUPPORT_STR_CORE_OFF)
#include "hw_pdwnc.h"
#endif

EXTERN VOID INT_Reset(VOID);
EXTERN VOID INT_Vectors(VOID);

EXTERN VOID CHIP_BootEntry0(VOID);
EXTERN VOID CHIP_BootEntry1(VOID);
EXTERN VOID CHIP_BootEntry2(VOID);
EXTERN VOID CHIP_BootEntry3(VOID);


VOID BSP_Start(VOID);
UINT32 au4BSS[4];
#if defined(CC_NAND_BOOT) || defined(CC_EMMC_BOOT)
EXTERN VOID ARM_InvalidateICache(VOID);
EXTERN VOID __aeabi_llsl(VOID);
//EXTERN VOID __aeabi_memclr4(VOID);
EXTERN VOID __aeabi_uidivmod(VOID);
EXTERN VOID x_memcpy(VOID);
EXTERN VOID CHIP_NANDCopyToDRAM(UINT32 *pu4DRAMBuf, UINT32 u4StartOffset, UINT32 u4Len);
#endif /* CC_NANDBOOT */

#if defined(CC_MTK_PRELOADER)
#if defined(CC_SUPPORT_EMI)
#if 0
#define EMI_CONM_OFFSET 	(0x60)
#define EMI_CONN_OFFSET 	(0x68)
#define CHN_EMI_CONC_OFFSET (0x10)

#else
typedef enum
{
	CHN_EMI0,
	CHN_EMI1,
	CHN_EMI2,
	CHN_EMI3,
	CHN_EMI_CNT
} CHN_EMI_TYPE_T;

#define CHN_EMI_NR     CHN_EMI_CNT


static unsigned long gCHNBaseAddr[CHN_EMI_NR]= {
CHN_EMI0_BASE, //Chn_emi0
CHN_EMI1_BASE, //Chn_emi1
CHN_EMI2_BASE, //Chn_emi2
CHN_EMI3_BASE, //Chn_emi3
};

#define EMI_CONA                   (0x0)
#define EMI_CONB                   (0x8)
#define EMI_CONC                   (0x10)
#define EMI_COND                   (0x18)
#define EMI_CONE                   (0x20)
#define EMI_CONF                   (0x28)
#define EMI_CONG                   (0x30)
#define EMI_CONH                   (0x38)
#define EMI_CONH_2ND               (0x3c)
#define EMI_CONI                   (0x40)
#define EMI_CONJ                   (0x48)
#define EMI_CONM                   (0x60)
#define EMI_CONN                   (0x68)
#define EMI_CONO                   (0x70)
#define EMI_MDCT                   (0x78)
#define EMI_MDCT_2ND               (0x7c)
#define EMI_LPCT0                  (0xa0)
#define EMI_LPCT1                  (0xa4)
#define EMI_LPCT2                  (0xa8)
#define EMI_LPCT5                  (0xb4)
#define EMI_LPCT6                  (0xb8)
#define EMI_IOCL                   (0xd0)
#define EMI_IOCL_2ND               (0xd4)
#define EMI_IOCM                   (0xd8)
#define EMI_IOCM_2ND               (0xdc)
#define EMI_TESTB                  (0xe8)
#define EMI_TESTC                  (0xf0)
#define EMI_TESTD                  (0xf8)
#define EMI_ARBA                   (0x100)
#define EMI_ARBC                   (0x110)
#define EMI_ARBD                   (0x118)
#define EMI_ARBE                   (0x120)
#define EMI_ARBF                   (0x128)
#define EMI_ARBG                   (0x130)
#define EMI_ARBH                   (0x138)
#define EMI_ARBI                   (0x140)
#define EMI_ARBI_2ND               (0x144)
#define EMI_ARBK                   (0x150)
#define EMI_ARBK_2ND               (0x154)
#define EMI_SLCT                   (0x158)
#define EMI_BMEN				   (0x400)

#define CHN_EMI_CONA               (0x0)
#define CHN_EMI_CONB               (0x8)
#define CHN_EMI_CONC               (0x10)
#define CHN_EMI_MDCT               (0x18)
#define CHN_EMI_COND               (0x20)
#define CHN_EMI_TESTA              (0x40)
#define CHN_EMI_TESTB              (0x48)
#define CHN_EMI_TESTC              (0x50)
#define CHN_EMI_TESTD              (0x58)
#define CHN_EMI_ARBI               (0x140)
#define CHN_EMI_ARBI_2ND           (0x144)
#define CHN_EMI_ARBJ               (0x148)
#define CHN_EMI_ARBJ_2ND           (0x14c)
#define CHN_EMI_ARBK               (0x150)
#define CHN_EMI_ARBK_2ND           (0x154)
#define CHN_EMI_SLCT               (0x158)
#define CHN_EMI_ARB_RFF            (0x15c)

#define TZ_ULTRA_EN_0              (0x138)  //agent0~3
#define TZ_ULTRA_EN_1			   (0x13c)  //agent4~7
#define TZ_ULTRA_EN_2			   (0x140)  //agent8~11
#define TZ_ULTRA_EN_3              (0x144)	//agent12~15
#define TZ_ULTRA_EN_4              (0x148)	//agent16~19
#define TZ_ULTRA_EN_5              (0x14c)  //agent20~23

#define TZ_PRE_ULTRA_EN_0          (0x150) //agent0~3
#define TZ_PRE_ULTRA_EN_1          (0x154) //agent4~7
#define TZ_PRE_ULTRA_EN_2          (0x158) //agent8~11
#define TZ_PRE_ULTRA_EN_3          (0x15c) //agent12~15
#define TZ_PRE_ULTRA_EN_4          (0x160) //agent16~19
#define TZ_PRE_ULTRA_EN_5          (0x164) //agent20~23

#define ADR_CHK_BUFFER0            (0x138) //
#define ADR_CHK_BUFFER1            (0x13c) //

#endif

void EMI_Init(void)
{
	UINT32 pre_ultra;
//	IO_WRITE32(IO_VIRT, 0xd210, 0x30);
	//====DMARB Init=====
	//bit[2]b'1  disable agent subid to emi
	IO_WRITE32(DRAM_DMARB_BASE, 0x0, 0xE0001B06);

	//enable agent0/angent5/agent15 for waiting SDLE option if r/w the same address
#if defined(CC_MT5893)
	if(BSP_GetIcVersion() >= IC_VER_5893_AB)
	{
		IO_WRITE32(DRAM_DMARB_BASE, ADR_CHK_BUFFER0, 0x8f8c8580);
		IO_WRITE32(DRAM_DMARB_BASE, ADR_CHK_BUFFER1, 0x8003008f);
	}
#endif

	//enable aout pre-ultra (agent0/sub0)
	pre_ultra = IO_READ32(DRAM_DMARB_TZ_BASE,TZ_PRE_ULTRA_EN_0);
	IO_WRITE32(DRAM_DMARB_TZ_BASE, TZ_PRE_ULTRA_EN_0,pre_ultra | 0xff);

	//enable dsp1 pre-ultra (agent5/sub0)
	pre_ultra = IO_READ32(DRAM_DMARB_TZ_BASE,TZ_PRE_ULTRA_EN_1);
	IO_WRITE32(DRAM_DMARB_TZ_BASE, TZ_PRE_ULTRA_EN_1,pre_ultra | 0xff00);

	//enable arm11 pre-ultra (agent12/sub0)
	pre_ultra = IO_READ32(DRAM_DMARB_TZ_BASE,TZ_PRE_ULTRA_EN_3);
	IO_WRITE32(DRAM_DMARB_TZ_BASE, TZ_PRE_ULTRA_EN_3,pre_ultra | 0xff);

	//enable dsp0 pre-ultra (agent15/sub0)
	pre_ultra = IO_READ32(DRAM_DMARB_TZ_BASE,TZ_PRE_ULTRA_EN_3);
	IO_WRITE32(DRAM_DMARB_TZ_BASE, TZ_PRE_ULTRA_EN_3,pre_ultra | 0xff000000);

	//mcSHOW_ERR_MSG((" start EMI init===\n\r"));
	#if 0
	//for 4-ch DDR4
	IO_WRITE32(EMI_REG_BASE,EMI_CONM_OFFSET,0xff000400);
	IO_WRITE32(EMI_REG_BASE,EMI_CONN_OFFSET,0x04800000);
	/*
	Quad channel
	Single rank
	Col 10bit
	Row 16bit
	Channel bit=axi addr bit8
	*/
	IO_WRITE32(EMI_REG_BASE,0x0,0x30103214);

	IO_WRITE32(CHN_EMI0_BASE,0x0,0x80003010);
	IO_WRITE32(CHN_EMI1_BASE,0x0,0x80003010);
	IO_WRITE32(CHN_EMI2_BASE,0x0,0x80003010);
	IO_WRITE32(CHN_EMI3_BASE,0x0,0x80003010);

	IO_WRITE32(CHN_EMI0_BASE,CHN_EMI_CONC_OFFSET,0x1);
	IO_WRITE32(CHN_EMI1_BASE,CHN_EMI_CONC_OFFSET,0x1);
	IO_WRITE32(CHN_EMI2_BASE,CHN_EMI_CONC_OFFSET,0x1);
	IO_WRITE32(CHN_EMI3_BASE,CHN_EMI_CONC_OFFSET,0x1);

	//mcSHOW_ERR_MSG(("end EMI init===\n\r"));
	#else
	int i;
	char Dram_size;
	
	Dram_size = DRVCUST_GetDramSize();

	if(Dram_size == DRAM_4G_CONFIG)
	{
		/*
		Quad channel
		Single rank
		Col 10bit
		Row 16bit
		Channel bit=axi addr bit8
		*/
		IO_WRITE32(EMI_REG_BASE,EMI_CONA,0x30103214);// ESL [9:8]:channel bits
	}
	else if(Dram_size == DRAM_3_5G_CONFIG)
	{
		//to do....
		/*
		Quad channel
		Single rank
		Col 10bit
		Row0 16bit  Row1 15bit
		Channel bit=axi addr bit8
		*/
		IO_WRITE32(EMI_REG_BASE,EMI_CONA,0x20103214);// ESL [9:8]:channel bits
	}
	else if(Dram_size == DRAM_3G_CONFIG)
	{
		/*
		Quad channel
		Single rank
		Col 10bit
		Row 15bit
		Channel bit=axi addr bit8
		*/
		IO_WRITE32(EMI_REG_BASE,EMI_CONA,0x20103214);// ESL [9:8]:channel bits
	}
	else if(Dram_size == DRAM_1_5G_CONFIG)
	{
		/*
		Quad channel
		Single rank
		Col 10bit
		Row 15bit
		Channel bit=axi addr bit8
		*/
		IO_WRITE32(EMI_REG_BASE,EMI_CONA,0x20102214);// ESL [9:8]:channel bits
	}
	else
	{
	//C:-------------------BEGIN EMI Setting--------------------
	#if defined(CC_SUPPORT_DRAM_4GB)
	/*
	Quad channel
	Single rank
	Col 10bit
	Row 16bit
	Channel bit=axi addr bit8
	*/
	IO_WRITE32(EMI_REG_BASE,EMI_CONA,0x30103214);// ESL [9:8]:channel bits
	#elif defined (CC_SUPPORT_DRAM_3_5GB)
	/*
		Quad channel
		Single rank
		Col 10bit
		Row0 16bit  Row1 15bit
		Channel bit=axi addr bit8
		*/
	IO_WRITE32(EMI_REG_BASE,EMI_CONA,0x20103214);// ESL [9:8]:channel bits
	#elif defined (CC_SUPPORT_DRAM_3GB)
	/*
	Quad channel
	Single rank
	Col 10bit
	Row 15bit
	Channel bit=axi addr bit8
	*/
	IO_WRITE32(EMI_REG_BASE,EMI_CONA,0x20103214);// ESL [9:8]:channel bits
	#elif defined (CC_SUPPORT_DRAM_2GB)
	/*
	Quad channel
	Single rank
	Col 10bit
	Row 15bit
	Channel bit=axi addr bit8
	*/
	IO_WRITE32(EMI_REG_BASE,EMI_CONA,0x20102214);// ESL [9:8]:channel bits
	#elif defined (CC_SUPPORT_DRAM_2_5GB)
	/*
	Quad channel
	Single rank
	Col 10bit
	Row 15bit
	Channel bit=axi addr bit8
	*/
	IO_WRITE32(EMI_REG_BASE,EMI_CONA,0x20103214);// ESL [9:8]:channel bits
	#elif defined (CC_SUPPORT_DRAM_1_5GB)
	/*
	Quad channel
	Single rank
	Col 10bit
	Row 15bit
	Channel bit=axi addr bit8
	*/
	IO_WRITE32(EMI_REG_BASE,EMI_CONA,0x20102214);// ESL [9:8]:channel bits
	#else //CC_SUPPORT_DRAM_4GB
	/*
	Quad channel
	Single rank
	Col 10bit
	Row 16bit
	Channel bit=axi addr bit8
	*/
	IO_WRITE32(EMI_REG_BASE,EMI_CONA,0x30103214);// ESL [9:8]:channel bits
	#endif
	}

	IO_WRITE32(EMI_REG_BASE,EMI_CONB,0x17283544);
	IO_WRITE32(EMI_REG_BASE,EMI_CONC,0x0a1a0b1a);
	IO_WRITE32(EMI_REG_BASE,EMI_COND,0x3657587a);
	IO_WRITE32(EMI_REG_BASE,EMI_CONE,0xffff0848);

	//==============Scramble address==========================
	IO_WRITE32(EMI_REG_BASE,EMI_CONF,0x00000000);
	IO_WRITE32(EMI_REG_BASE,EMI_CONG,0x2b2b2a38);
	IO_WRITE32(EMI_REG_BASE,EMI_CONH,0x00000000);
	IO_WRITE32(EMI_REG_BASE,EMI_CONI,0x00008803);
	IO_WRITE32(EMI_REG_BASE,EMI_CONM,0x000006ff);
	
	if(Dram_size == DRAM_4G_CONFIG)
	{
		IO_WRITE32(EMI_REG_BASE,EMI_CONN,0x04800000); //[23]: reg_bg_en ,for PCDDR4
	}
	else if(Dram_size == DRAM_3_5G_CONFIG)
	{
		//to do
		IO_WRITE32(EMI_REG_BASE,EMI_CONN,0x04880000); //[23]: reg_bg_en ,for PCDDR4
	}
	else if(Dram_size == DRAM_3G_CONFIG)
	{		
      #if defined(CC_32BIT_INTERLEAVE_SUPPORT)
      	IO_WRITE32(EMI_REG_BASE,EMI_CONN,0x04C40000); //[23]: reg_bg_en ,for PCDDR4;[22]:dual_chn_itlv_en,for interleave;[18]:dram_3gb_en,for 3GB config
      #else
      	IO_WRITE32(EMI_REG_BASE,EMI_CONN,0x04840000); //[23]: reg_bg_en ,for PCDDR4;[18]:dram_3gb_en,for 3GB config
      #endif		
	}
	else if(Dram_size == DRAM_1_5G_CONFIG)
	{
		//to do
		IO_WRITE32(EMI_REG_BASE,EMI_CONN,0x04810000); //[23]: reg_bg_en ,for PCDDR4
	}
	else
	{
	#if defined(CC_SUPPORT_DRAM_4GB)
		IO_WRITE32(EMI_REG_BASE,EMI_CONN,0x04800000); //[23]: reg_bg_en ,for PCDDR4
	#elif defined (CC_SUPPORT_DRAM_3GB)
		#if defined(CC_32BIT_INTERLEAVE_SUPPORT)
		IO_WRITE32(EMI_REG_BASE,EMI_CONN,0x04C40000); //[23]: reg_bg_en ,for PCDDR4;[22]:dual_chn_itlv_en,for interleave;[18]:dram_3gb_en,for 3GB config
		#else
		IO_WRITE32(EMI_REG_BASE,EMI_CONN,0x04840000); //[23]: reg_bg_en ,for PCDDR4;[18]:dram_3gb_en,for 3GB config
		#endif
	#elif defined (CC_SUPPORT_DRAM_3_5GB)
		IO_WRITE32(EMI_REG_BASE,EMI_CONN,0x04880000); //[23]: reg_bg_en ,for PCDDR4;[18]:dram_3gb_en,for 3.5GB config
	#elif defined (CC_SUPPORT_DRAM_2GB)
		IO_WRITE32(EMI_REG_BASE,EMI_CONN,0x04800000); //[23]: reg_bg_en ,for PCDDR4
	#elif defined (CC_SUPPORT_DRAM_2_5GB)
		IO_WRITE32(EMI_REG_BASE,EMI_CONN,0x04820000); //[23]: reg_bg_en ,for PCDDR4;[17]:dram_2p5gb_en,for 2.5GB config
	#elif defined (CC_SUPPORT_DRAM_1_5GB)
		IO_WRITE32(EMI_REG_BASE,EMI_CONN,0x04810000); //[23]: reg_bg_en ,for PCDDR4;[17]:dram_2p5gb_en,for 1.5GB config
	#else//CC_SUPPORT_DRAM_4GB
		IO_WRITE32(EMI_REG_BASE,EMI_CONN,0x04800000); //[23]: reg_bg_en ,for PCDDR4;[17]:dram_2p5gb_en,for 4GB config
	#endif
	}
	IO_WRITE32(EMI_REG_BASE,EMI_MDCT,0x9a998c10);
	IO_WRITE32(EMI_REG_BASE,EMI_MDCT_2ND,0x00002300); //ESL :  Reserved Buffer
	IO_WRITE32(EMI_REG_BASE,EMI_IOCL,0xa8afa8a8);
	IO_WRITE32(EMI_REG_BASE,EMI_IOCL_2ND,0x25272525);
	IO_WRITE32(EMI_REG_BASE,EMI_IOCM,0xa8a8a8af);
	IO_WRITE32(EMI_REG_BASE,EMI_IOCM_2ND,0x25252527);
	IO_WRITE32(EMI_REG_BASE,EMI_TESTB,0x00000027); //disable MDMCU super
	IO_WRITE32(EMI_REG_BASE,EMI_TESTC,0x38460000);
	IO_WRITE32(EMI_REG_BASE,EMI_TESTD,0x00000000);
/////  EMI  bandwidth limit  ///////// default ui
	IO_WRITE32(EMI_REG_BASE,EMI_ARBA,0xf0f07341);
	IO_WRITE32(EMI_REG_BASE,0x108,0xf0f07041);
#ifdef Support4KVideoBrowser
	IO_WRITE32(EMI_REG_BASE,EMI_ARBC,0xffff70d8);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBD,0xf04070c3);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBE,0xffff70d4);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBF,0xffff70cb);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBG,0xffff7042);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBH,0xffff7042);
#else
#ifdef PIP_FHDVENC
	IO_WRITE32(EMI_REG_BASE,EMI_ARBC,0xffff70d4);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBD,0xf04070c4);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBE,0xffff70d3);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBF,0xffff70d3);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBG,0xffff7040);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBH,0xffff7040);
#else //default
	IO_WRITE32(EMI_REG_BASE,EMI_ARBC,0xffff70db);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBD,0xf04070c4);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBE,0xffff70d5);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBF,0xffff70ca);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBG,0xFFFF304F);
	IO_WRITE32(EMI_REG_BASE,EMI_ARBH,0xFFFF304F);
#endif
#endif
	////////////////////////////////////////////////////
	IO_WRITE32(EMI_REG_BASE,EMI_ARBI,0x00006108);
	IO_WRITE32(EMI_REG_BASE,EMI_SLCT,0x0001ff00);
	IO_WRITE32(EMI_REG_BASE,EMI_BMEN,0x00000001);
	//-------------------END EMI Setting--------------------;

	//-------------------BEGIN CHANNEL EMI Setting--------------------;
	for (i = 0; i < CHN_EMI_NR; i++)
	{
		if(Dram_size == DRAM_4G_CONFIG)
		{
			IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80003010); //# Channel EMI row bit 16bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
		}
		else if(Dram_size == DRAM_3_5G_CONFIG)
		{
			//to do
			if(i == CHN_EMI3)
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80002010); //# Channel EMI row bit 15bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
			else
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80003010); //# Channel EMI row bit 16bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
		}
		else if(Dram_size == DRAM_3G_CONFIG)
		{
			if(i == CHN_EMI0 || i == CHN_EMI1)
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80003010); //# Channel EMI row bit 16bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
			else
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80002010); //# Channel EMI row bit 15bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
		}
		else if(Dram_size == DRAM_1_5G_CONFIG)
		{
			if(i == CHN_EMI0 || i == CHN_EMI1 || i == CHN_EMI2)
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80002010); //# Channel EMI row bit 15bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
			else
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x0); //# don't care
		}
		else
		{
			#if defined(CC_SUPPORT_DRAM_4GB) //8-8-8-8
			IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80003010); //# Channel EMI row bit 16bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
			#elif defined (CC_SUPPORT_DRAM_3GB) //8-8-4-4
			if(i == CHN_EMI0 || i == CHN_EMI1)
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80003010); //# Channel EMI row bit 16bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
			else
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80002010); //# Channel EMI row bit 15bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
			#elif defined (CC_SUPPORT_DRAM_3_5GB) //8-8-8-4
			if(i == CHN_EMI3)
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80002010); //# Channel EMI row bit 15bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
			else
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80003010); //# Channel EMI row bit 16bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
			#elif defined (CC_SUPPORT_DRAM_2GB) //4-4-4-4
			IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80002010); //# Channel EMI row bit 15bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
			#elif defined (CC_SUPPORT_DRAM_2_5GB) //8-4-4-4
			if(i == CHN_EMI0)
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80003010); //# Channel EMI row bit 16bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
			else
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80002010); //# Channel EMI row bit 15bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
			#elif defined (CC_SUPPORT_DRAM_1_5GB) //4-4-4-0
			if(i == CHN_EMI0 || i == CHN_EMI1 || i == CHN_EMI2)
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80002010); //# Channel EMI row bit 15bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
			else
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x0); //# don't care
			#else////CC_SUPPORT_DRAM_4GB   //8-8-8-8
				IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONA,0x80003010); //# Channel EMI row bit 16bit, disable LP4_SUPPORT(bit26), enable reg_bg_en(bit31)
			#endif
		}
		IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONB,0xffff1048);
		IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_CONC,0x00000001);
		IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_COND,0x400f800f); //0x400f800f=>0x40f8000f
		//IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_MDCT,0x88028c17);
		IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_TESTB,0x00240027);
		IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_TESTC,0x38460000);
		IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_TESTD,0x00000000);
		IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_ARBI,0x20406188);
		//IO_WRITE32(gCHNBaseAddr(i),CHN_EMI_ARBI_2ND,0x20406188);
		IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_ARBJ,0x3719595e);
		//IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_ARBJ_2ND,0x3719595e);
		IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_ARBK,0x64f3fc79);
		IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_ARBK_2ND,0x64f3fc79);
		IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_SLCT,0x00000000); // disable M3 LLAT EN
		IO_WRITE32(gCHNBaseAddr[i],CHN_EMI_ARB_RFF,0x82410222); // [31]=1: ultra read first, [28:24] write threshold=2 //STRICT_MSK_ULTRA_EN [5]=1
	}
	//-------------------END CHANNEL EMI Setting--------------------;
	#endif
	return;
}
#endif
#if defined(CC_SUPPORT_SMI)

#define PERLOARD_SMI_LARB_MMU_ENABLE (0)   //1: enable larb mmu, 0:disable larb mmu

typedef enum
{
	P_SMI_LARB0,
	P_SMI_LARB1,
	P_SMI_LARB2,
	P_SMI_LARB3,
	P_SMI_LARB4,
	P_SMI_LARB5,
	P_SMI_LARB6,
	P_SMI_LARB7,
	P_SMI_LARB8,
	P_SMI_LARB9,
	P_SMI_LARB10,
	P_SMI_LARB11,
	P_SMI_LARB12,
	P_SMI_LARB_CNT
} P_SMI_LARB_TYPE_T;

#define P_SMI_LARB_NR     P_SMI_LARB_CNT

#define P_SMI_LARB0_PORT_NUM  10
#define P_SMI_LARB1_PORT_NUM  10
#define P_SMI_LARB2_PORT_NUM  3
#define P_SMI_LARB3_PORT_NUM  11
#define P_SMI_LARB4_PORT_NUM  11
#define P_SMI_LARB5_PORT_NUM  22
#define P_SMI_LARB6_PORT_NUM  2
#define P_SMI_LARB7_PORT_NUM  6
#define P_SMI_LARB8_PORT_NUM  17
#define P_SMI_LARB9_PORT_NUM  11
#define P_SMI_LARB10_PORT_NUM  9
#define P_SMI_LARB11_PORT_NUM  24
#define P_SMI_LARB12_PORT_NUM  14

#define P_SMI_LARB_NON_SEC_CON            (0x380) //new
#define P_SMI_LARB_SEC_CON                (0xF80) //new
#define P_SMI_LARB_CMD_THRT_CON           (0x24)

unsigned long gPLarbBaseAddr[P_SMI_LARB_NR]= {
SMI_LARB0_BASE, //larb0
SMI_LARB1_BASE, //larb1
SMI_LARB2_BASE, //larb2
SMI_LARB3_BASE, //larb3
SMI_LARB4_BASE, //larb4
SMI_LARB5_BASE, //larb5
SMI_LARB6_BASE, //larb6
SMI_LARB7_BASE, //larb7
SMI_LARB8_BASE, //larb8
SMI_LARB9_BASE, //larb9
SMI_LARB10_BASE, //larb10
SMI_LARB11_BASE, //larb11
SMI_LARB12_BASE  //larb12
};


static void perloader_disable_larb_mmu(int larbIndex)
{
	char i = 0;
	switch (larbIndex) {
	case P_SMI_LARB0:
		for(i=0 ;i < P_SMI_LARB0_PORT_NUM ;i++)
		{
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_NON_SEC_CON+(4*i),0x0); //non-secure
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_SEC_CON+(4*i),0x0); // secure
		}
		return ;
	case P_SMI_LARB1:
		for(i=0 ;i < P_SMI_LARB1_PORT_NUM ;i++)
		{
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_NON_SEC_CON+(4*i),0x0); //non-secure
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_SEC_CON+(4*i),0x0); // secure
		}
		return ;
	case P_SMI_LARB2:
		for(i=0 ;i < P_SMI_LARB2_PORT_NUM ;i++)
		{
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_NON_SEC_CON+(4*i),0x0); //non-secure
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_SEC_CON+(4*i),0x0); // secure
		}
		return ;
	case P_SMI_LARB3:
		for(i=0 ;i < P_SMI_LARB3_PORT_NUM ;i++)
		{
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_NON_SEC_CON+(4*i),0x0); //non-secure
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_SEC_CON+(4*i),0x0); // secure
		}
		return ;
	case P_SMI_LARB4:
		for(i=0 ;i < P_SMI_LARB4_PORT_NUM ;i++)
		{
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_NON_SEC_CON+(4*i),0x0); //non-secure
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_SEC_CON+(4*i),0x0); // secure
		}
		return ;
	case P_SMI_LARB5:
		for(i=0 ;i < P_SMI_LARB5_PORT_NUM ;i++)
		{
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_NON_SEC_CON+(4*i),0x0); //non-secure
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_SEC_CON+(4*i),0x0); // secure
		}
		return ;
	case P_SMI_LARB6:
		for(i=0 ;i < P_SMI_LARB6_PORT_NUM ;i++)
		{
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_NON_SEC_CON+(4*i),0x0); //non-secure
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_SEC_CON+(4*i),0x0); // secure
		}
		return ;
	case P_SMI_LARB7:
		for(i=0 ;i < P_SMI_LARB7_PORT_NUM ;i++)
		{
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_NON_SEC_CON+(4*i),0x0); //non-secure
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_SEC_CON+(4*i),0x0); // secure
		}
		return ;
	case P_SMI_LARB8:
		for(i=0 ;i < P_SMI_LARB8_PORT_NUM ;i++)
		{
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_NON_SEC_CON+(4*i),0x0); //non-secure
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_SEC_CON+(4*i),0x0); // secure
		}
		return ;
	case P_SMI_LARB9:
		for(i=0 ;i < P_SMI_LARB9_PORT_NUM ;i++)
		{
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_NON_SEC_CON+(4*i),0x0); //non-secure
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_SEC_CON+(4*i),0x0); // secure
		}
		return ;
	case P_SMI_LARB10:
		for(i=0 ;i < P_SMI_LARB10_PORT_NUM ;i++)
		{
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_NON_SEC_CON+(4*i),0x0); //non-secure
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_SEC_CON+(4*i),0x0); // secure
		}
		return ;
	case P_SMI_LARB11:
		for(i=0 ;i < P_SMI_LARB11_PORT_NUM ;i++)
		{
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_NON_SEC_CON+(4*i),0x0); //non-secure
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_SEC_CON+(4*i),0x0); // secure
		}
		return ;
	case P_SMI_LARB12:
		for(i=0 ;i < P_SMI_LARB12_PORT_NUM ;i++)
		{
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_NON_SEC_CON+(4*i),0x0); //non-secure
			IO_WRITE32(gPLarbBaseAddr[larbIndex],P_SMI_LARB_SEC_CON+(4*i),0x0); // secure
		}
		return ;
	default:
		return ;
	}
}

static void preloader_set_throtting(void)
{
	IO_WRITE32(gPLarbBaseAddr[P_SMI_LARB0],P_SMI_LARB_CMD_THRT_CON,((0x6<<0) + (0x4<<4) + (0x2<<8) + (0x1<<16) + (0x1<<17) + (0x1<<18) + (0x3<<20)));
	IO_WRITE32(gPLarbBaseAddr[P_SMI_LARB1],P_SMI_LARB_CMD_THRT_CON,((0x6<<0) + (0x4<<4) + (0x2<<8) + (0x1<<16) + (0x1<<17) + (0x1<<18) + (0x3<<20)));
	IO_WRITE32(gPLarbBaseAddr[P_SMI_LARB2],P_SMI_LARB_CMD_THRT_CON,((0x6<<0) + (0x4<<4) + (0x2<<8) + (0x1<<16) + (0x1<<17) + (0x1<<18) + (0x3<<20)));
	IO_WRITE32(gPLarbBaseAddr[P_SMI_LARB3],P_SMI_LARB_CMD_THRT_CON,((0x6<<0) + (0x4<<4) + (0x2<<8) + (0x1<<16) + (0x1<<17) + (0x1<<18) + (0x3<<20)));
	IO_WRITE32(gPLarbBaseAddr[P_SMI_LARB4],P_SMI_LARB_CMD_THRT_CON,((0x6<<0) + (0x4<<4) + (0x2<<8) + (0x1<<16) + (0x1<<17) + (0x1<<18) + (0x3<<20)));
	IO_WRITE32(gPLarbBaseAddr[P_SMI_LARB5],P_SMI_LARB_CMD_THRT_CON,((0x6<<0) + (0x4<<4) + (0x2<<8) + (0x1<<16) + (0x1<<17) + (0x1<<18) + (0x3<<20)));
	IO_WRITE32(gPLarbBaseAddr[P_SMI_LARB6],P_SMI_LARB_CMD_THRT_CON,((0x6<<0) + (0x4<<4) + (0x2<<8) + (0x1<<16) + (0x1<<17) + (0x1<<18) + (0x3<<20)));
	IO_WRITE32(gPLarbBaseAddr[P_SMI_LARB7],P_SMI_LARB_CMD_THRT_CON,((0x6<<0) + (0x4<<4) + (0x2<<8) + (0x1<<16) + (0x1<<17) + (0x1<<18) + (0x3<<20)));
	IO_WRITE32(gPLarbBaseAddr[P_SMI_LARB8],P_SMI_LARB_CMD_THRT_CON,((0x6<<0) + (0x4<<4) + (0x2<<8) + (0x1<<16) + (0x1<<17) + (0x1<<18) + (0x3<<20)));
	IO_WRITE32(gPLarbBaseAddr[P_SMI_LARB9],P_SMI_LARB_CMD_THRT_CON,((0x6<<0) + (0x4<<4) + (0x2<<8) + (0x1<<16) + (0x1<<17) + (0x1<<18) + (0x3<<20)));
	IO_WRITE32(gPLarbBaseAddr[P_SMI_LARB10],P_SMI_LARB_CMD_THRT_CON,((0x6<<0) + (0x4<<4) + (0x2<<8) + (0x1<<16) + (0x1<<17) + (0x1<<18) + (0x3<<20)));
	IO_WRITE32(gPLarbBaseAddr[P_SMI_LARB11],P_SMI_LARB_CMD_THRT_CON,((0x6<<0) + (0x4<<4) + (0x2<<8) + (0x1<<16) + (0x1<<17) + (0x1<<18) + (0x3<<20)));
	IO_WRITE32(gPLarbBaseAddr[P_SMI_LARB12],P_SMI_LARB_CMD_THRT_CON,((0x6<<0) + (0x4<<4) + (0x2<<8) + (0x1<<16) + (0x1<<17) + (0x1<<18) + (0x3<<20)));
}

void SMI_Init(void)
{
	char i;

	if(!PERLOARD_SMI_LARB_MMU_ENABLE)
	{
		//disable larb0~12
		for (i = 0; i < P_SMI_LARB_NR; i++)
			perloader_disable_larb_mmu(i);
	}

	//set SMI throtting
	preloader_set_throtting();
	
	return;
}
#endif

#endif

VOID BSPLinkSymbol(UINT32 fgDisplay)
{
    if (fgDisplay)
    {
        INT_Reset();
        INT_Vectors();
        BSPLinkSymbol(au4BSS[0]);
#if defined(CC_NAND_BOOT) || defined(CC_EMMC_BOOT)
        __aeabi_llsl();     // for llshl.o(c_5.l)
        x_memcpy();         // mem_mgr.o
        __aeabi_uidivmod(); // aeabi_sdiv.o(.text_udiv)
      //  __aeabi_memclr4();  // rt_memclr_w.o
#endif /* CC_NANDBOOT */
    }
}

#define TIME_START(x) \
    BIM_WRITE32((x), 0x12345678); \
    IO_WRITE32MSK(BIM_BASE, REG_RW_TIMER_CTRL, 0, TMR1_CNTDWN_EN | TMR1_AUTOLD_EN); \
    BIM_WRITE32(REG_RW_TIMER1_LLMT, 0xffffffff); \
    BIM_WRITE32(REG_RW_TIMER1_LOW , 0xffffffff); \
    IO_WRITE32MSK(BIM_BASE, REG_RW_TIMER_CTRL, TMR1_CNTDWN_EN | TMR1_AUTOLD_EN, TMR1_CNTDWN_EN | TMR1_AUTOLD_EN);

#define TIME_END(x) \
    IO_WRITE32MSK(BIM_BASE, REG_RW_TIMER_CTRL, 0, TMR1_CNTDWN_EN | TMR1_AUTOLD_EN); \
    BIM_WRITE32((x), ~BIM_READ32(REG_RW_TIMER1_LOW));

VOID BSP_Start()
{
#ifndef CONFIG_64BIT
    BIM_WRITE32(0x008, BIM_READ32(0x008) & (~0x900));
#endif
#ifdef CC_FPGA_SIM

    HalInitMMU(TCMGET_CHANNELA_SIZE() * 0x100000 - 0x4000);
    DhrystoneTest(10);
    do
    {
    }
    while (1);

#endif

    CHIP_BootEntry0();

#if defined(CC_SUPPORT_STR_CORE_OFF) && defined(CC_MTK_PRELOADER)
    // Check for resume from suspend to dram
    extern void CHIP_ResumeFormSuspendMode();
	CHIP_ResumeFormSuspendMode();
	#if (defined(CC_MT5891) || defined(CC_MT5886) || defined(CC_MT5893))&&(!defined(CC_MTK_HOTBOOT_PRELOADER))
	extern UINT32 CHIP_CheckWdtResume(void);
	if(!CHIP_CheckWdtResume())
	{
	#endif
#endif   /* CC_SUPPORT_STR_CORE_OFF && CC_MTK_PRELOADER */
#ifndef CC_MTK_HOTBOOT_PRELOADER
    if (!BSP_IsFPGA())
    {
        CHIP_BootEntry1();
#if defined(CC_MTK_PRELOADER)
#if defined(CC_SUPPORT_EMI)
		EMI_Init();  //EMI init after dramc calibration (hotboot resume must init again)
#endif
#if defined(CC_SUPPORT_SMI)
		SMI_Init();  //SMI disable MMU,before osd will access dram on loader or kernel early init
#endif
#endif
        CHIP_BootEntry2();
    }
#if defined(CC_SUPPORT_STR_CORE_OFF) && defined(CC_MTK_PRELOADER) && (defined(CC_MT5891) || defined(CC_MT5886)|| defined(CC_MT5893))
	}
#endif   /* CC_SUPPORT_STR_CORE_OFF && CC_MTK_PRELOADER */
    CHIP_BootEntry3();
#endif
}

#if defined(CC_MTK_PRELOADER) && defined(CC_TRUSTZONE_SUPPORT)
void *CHIP_TzEntry(void)
{
    return (void *)TRUSTZONE_ENTRY;
}
#endif // CC_TRUSTZONE_SUPPORT

