/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/


//----------------------------------------------------------------------------
// Check direct compile this file
//----------------------------------------------------------------------------
#ifndef NO_IMP
#define NO_IMP
#include "drvcust_lib.c"
#define IMP_DRV_MAPLE_SET_API_C
#endif  /* NO_IMP */
#include "macro_helper.h"

#include "drv_MapleSetApi.h"
#include "drv_MapleApi.h"
#include "nptv_debug.h"
#include "pdwnc_if.h"
#include "msdc_if.h"
#include "hw_ycproc.h"
#include "hw_ospe.h"
#include "panel.h"
#include "panel_cust.h"

#ifdef CC_SUPPORT_DOLBY_VISION
#include "../../dolby/drv_dolby_drvif.h"
#endif

//----------------------------------------------------------------------------
// Check direct compile this file
//----------------------------------------------------------------------------
#ifdef IMP_DRV_MAPLE_SET_API_C
#undef NO_IMP
#include "macro_helper.h"
#endif  /* IMP_DRV_MAPLE_SET_API_C */
//No more #include after this point!!

// === DEFINE =============================================================================
#define CLIP(val, min, max) ((val>=max) ? max : ((val<=min) ? min : val))
#define LOAD_PANEL_FROM_FLASH_BY_NAME 1

/************************** Global Variable *******************************/
VAR_MACRO(SONY_PQ_FUNC_T* sony_pq_func, = NULL);
VAR_MACRO(SONY_BE_FUNC_T* sony_be_func, = NULL);
VAR_MACRO(SONY_BE_GEN_FUNC_T* sony_be_gen_func, = NULL);
VAR_MACRO(SONY_PQ_GEN_FUNC_T* sony_pq_gen_func, = NULL);
VAR_MACRO(SONY_BE_EXT_FUNC_T* sony_be_ext_func, = NULL);
MOD_MACRO UINT8 gU1EnSetTnr;
VAR_MACRO(UINT8 gU1PreEnSetTnr, = 0xFF);

MOD_MACRO UINT8  gu1EcsCommandReply[256];
MOD_MACRO UINT32  gu4EcsCommandReplySize;
VAR_MACRO(UINT32	gBEErrorDetect, = 0x00);
MOD_MACRO E_BE_DEVICE		gBEDevice;
MOD_MACRO UINT32		gBEDeviceInfoSize;
MOD_MACRO VOID*		gBEInfoPara;

VAR_MACRO(UINT8   gBEVersionNum, = 8);
VAR_MACRO(UINT8*  gBEVersion, = NULL);
VAR_MACRO(BOOL fgBEVersionIsSet, = FALSE);
MOD_MACRO UINT16 u2LumaArrayBuf[LUMA_CURVE_NUM_65]; 
MOD_MACRO UINT16 u2SkinArrayBuf[LUMA_CURVE_NUM_65]; 
MOD_MACRO UINT16 u2ContrastBuf, u2ColorBuf, u2HueBuf, u2BrightnessBuf;
MOD_MACRO UINT16 u2MatrixContrastBuf, u2MatrixColorBuf, u2MatrixHueBuf, u2MatrixBrightnessBuf;
MOD_MACRO UINT32 PhyAddrBuf_A, PhyAddrBuf_B;
VAR_MACRO(UINT32 u4BufFlag, = 0);
MOD_MACRO CUST_SHARP_OFST_T stSharpOfst;
MOD_MACRO UINT8 u1SceYSlope[SCE_LUMA_HUE_SLICE];
MOD_MACRO UINT8 u1SceSGain1[SCE_HUE_SLICE];
MOD_MACRO UINT8 u1SceSGain2[SCE_HUE_SLICE];
MOD_MACRO UINT8 u1SceSGain3[SCE_HUE_SLICE];
MOD_MACRO CUST_RGB_GAIN_OFST_T stRGBGainOfst;
extern BOOL fgCriticalSection;
MOD_MACRO UINT8 u1YLevArrayBuf[17];
MOD_MACRO UINT8 u1YLevIBSEArrayBuf[17]; 

MOD_MACRO CUST_4BAND_FILTER_RANGE CUST_4BAND_HIST_FILTER_RANGE;
MOD_MACRO CUST_4BAND_H_FILTER CUST_4BAND_HIST_FILTER;
MOD_MACRO CUST_CAP_DATA_T CUST_CAP_DATA;
MOD_MACRO CUST_SCE_CAP_DATA_T CUST_SCE_CAP_DATA;
#define COL_CONV_MAX_NUM (400)
MOD_MACRO CUST_COL_CONV_TABLE_PARAM_T CUST_COL_CONV_TABLE_PARAM[COL_CONV_MAX_NUM];
VAR_MACRO(UINT16 u1ConvTblParamIDX,=0);
extern BOOL CustomPanelLoadTableFromFlash(UINT32 u4Type, void *pData);

FUN_MACRO(void vDrvSetSRS(UINT32 u4Addr_A, UINT32 u4Addr_B))
#ifdef IMP_DRV_MAPLE_SET_API_C
{       
    LOG(2, "DRVCUST_SetSRSLut Table A Addr 0x%08x Table B Addr 0x%08x \n", u4Addr_A, u4Addr_B);

    if (IO32ReadFldAlign(SRS_3, STA_TBL_UPDATE))
    {        
        LOG(0, "DRVCUST_SetSRSLut Busy !!!! \n");
        return;
    }

    if (u4Addr_A && u4Addr_B)
    {
    	
        vIO32WriteFldAlign(SRS_0, (u4Addr_A & 0x0FFFFFF0)>>4, C_SRS_DRAM_ADR_A);
        vIO32WriteFldAlign(SRS_2, (u4Addr_B & 0x0FFFFFF0)>>4, C_SRS_DRAM_ADR_B);
		vIO32WriteFldAlign(SRS_1, (u4Addr_A & 0x70000000)>>28, C_SRS_ADDR_MSB);

        vIO32WriteFldAlign(SRS_0, 1, C_TBL_UPDATE_TRIG);
        vIO32WriteFldAlign(SRS_0, 0, C_TBL_UPDATE_TRIG);
    }
    else
    {
        LOG(0, "DRVCUST_SetSRSLut Parametes error !!!! \n");
    }    
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

/*************************** functions ************************************/
FUN_MACRO(void DRVCUST_SetExclusiveReg(UINT8 u1Enable))
#ifdef IMP_DRV_MAPLE_SET_API_C
{

	vDrvADLSetYHistogramMode(u1Enable ? 2 : 0);
	vDrvADLSetLumaCurveMode(u1Enable ? 0 : 1);
    vDrvADLManualLumaCurveOnOff(u1Enable ? 1 : 0);
	vDrvADLOnOff(u1Enable ? 0 : 1);
    vDrvSCECalculateOnOff(u1Enable ? 0 : 1);

    if (u1Enable == SV_FALSE)
    {
        // reset to default 
        DRVCUST_SetContrast(0x80);
        DRVCUST_SetColor(0x80);
        DRVCUST_SetHue(0x80);
    }

    // SRS todo

    LOG(2, "DRVCUST_SetExclusiveReg %d \n", u1Enable); 
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetLumaCurve(const UINT16 * waLArray,const UINT16 * waSkinLArray))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    x_memcpy(u2LumaArrayBuf, waLArray, LUMA_CURVE_NUM_65*sizeof(UINT16));
	x_memcpy(u2SkinArrayBuf, waSkinLArray, LUMA_CURVE_SKIN_NUM_65*sizeof(UINT16));
    u4BufFlag |= E_CUST_PQ_BUF_LUMA_CURVE;
    //LOG(2, "DRVCUST_SetLumaCurve \n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetContrast(UINT16 u2Value))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    u2ContrastBuf = u2Value;      
    u4BufFlag |= E_CUST_PQ_BUF_COMTRAST;
    //LOG(2, "DRVCUST_SetContrast %d \n", u2Value);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetColor(UINT16 u2Value))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    u2ColorBuf= u2Value;  
    
    u4BufFlag |= E_CUST_PQ_BUF_COLOR;
    //LOG(2, "DRVCUST_SetColor %d \n", u2Value);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetHue(UINT16 u2Value))
#ifdef IMP_DRV_MAPLE_SET_API_C
{    
    u2HueBuf = u2Value;  
    #ifndef CC_MTK_AUTO_TEST
    u4BufFlag |= E_CUST_PQ_BUF_HUE;
    //LOG(2, "DRVCUST_SetHue %d \n", u2Value);
    #else
	vIO32WriteFldAlign(G_PIC_ADJ_MAIN_2,u2Value<<2, HUE);
    #endif
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetPqWBGainOffset(CUST_RGB_GAIN_OFST_T * pstRgbGainOfst))
#ifdef IMP_DRV_MAPLE_SET_API_C
{        
    if (pstRgbGainOfst != NULL)
    {
        x_memcpy(&stRGBGainOfst, pstRgbGainOfst, sizeof(CUST_RGB_GAIN_OFST_T));
    }
    else
    {
        LOG(0, "DRVCUST_SetPqWBGainOffset Failed !!!!\n");
        return;
    }

    u4BufFlag |= E_CUST_PQ_BUF_RGB_GAIN_OFST;
    //LOG(2, "DRVCUST_SetPqWBGainOffset\n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_GetPqWBGainOffset(CUST_RGB_GAIN_OFST_T * pstRgbGainOfst))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    if (pstRgbGainOfst != NULL)
    {
        pstRgbGainOfst->u2RGain = IO32ReadFldAlign(GAINOSET_00, R_GAIN_MAIN);
        pstRgbGainOfst->u2GGain = IO32ReadFldAlign(GAINOSET_00, G_GAIN_MAIN);
        pstRgbGainOfst->u2BGain = IO32ReadFldAlign(GAINOSET_00, B_GAIN_MAIN);
        pstRgbGainOfst->u2ROffset = IO32ReadFldAlign(GAINOSET_02, R_OFST1_MAIN);
        pstRgbGainOfst->u2GOffset = IO32ReadFldAlign(GAINOSET_02, G_OFST1_MAIN);
        pstRgbGainOfst->u2BOffset = IO32ReadFldAlign(GAINOSET_02, B_OFST1_MAIN);
    }
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetSharpnessOffset(CUST_SHARP_OFST_T * pSharpOfst))
#ifdef IMP_DRV_MAPLE_SET_API_C
{   
    if (pSharpOfst != NULL)
    {
        x_memcpy(&stSharpOfst, pSharpOfst, sizeof(CUST_SHARP_OFST_T));
    }
    else
    {
        LOG(0, "DRVCUST_SetSharpnessOffset Failed !!!!\n");
        return;
    }
    
    u4BufFlag |= E_CUST_PQ_BUF_SHARPNESS; 

	#if 0
    LOG(2, "DRVCUST_SetSharpnessOffset\n");
    
    LOG(2, "GainH           %d %d %d \n", 
        stSharpOfst.u1GainH[0], stSharpOfst.u1GainH[1], stSharpOfst.u1GainH[2]);
    LOG(2, "GainV           %d %d %d \n", 
        stSharpOfst.u1GainV[0], stSharpOfst.u1GainV[1], stSharpOfst.u1GainV[2]);
    LOG(2, "GainD           %d %d %d \n", 
        stSharpOfst.u1GainD[0], stSharpOfst.u1GainD[1], stSharpOfst.u1GainD[2]);    
    LOG(2, "CoringZeroH     %d %d %d \n", 
        stSharpOfst.u1CorzH[0], stSharpOfst.u1CorzH[1], stSharpOfst.u1CorzH[2]);        
    LOG(2, "CoringZeroV     %d %d %d \n", 
        stSharpOfst.u1CorzV[0], stSharpOfst.u1CorzV[1], stSharpOfst.u1CorzV[2]);
    LOG(2, "CoringZeroD     %d %d %d \n", 
        stSharpOfst.u1CorzD[0], stSharpOfst.u1CorzD[1], stSharpOfst.u1CorzD[2]);
	LOG(2, "HSHPGainLow          %d %d \n", 
        stSharpOfst.u1HSHPGainLow[0], stSharpOfst.u1HSHPGainLow[1]);
    LOG(2, "HSHPGainMid          %d %d \n", 
        stSharpOfst.u1HSHPGainMid[0], stSharpOfst.u1HSHPGainMid[1]);
    LOG(2, "HSHPGainHigh         %d %d \n", 
        stSharpOfst.u1HSHPGainHigh[0], stSharpOfst.u1HSHPGainHigh[1]);    
    LOG(2, "HSHPCoringZero     %d %d %d \n", 
        stSharpOfst.u1HSHPCor[0], stSharpOfst.u1HSHPCor[1], stSharpOfst.u1HSHPCor[2]);        
    LOG(2, "EdgeGain     %d %d %d \n", 
        stSharpOfst.u1EdgeGain[0], stSharpOfst.u1EdgeGain[1], stSharpOfst.u1EdgeGain[2]);
    LOG(2, "DetailGain     %d %d %d \n", 
        stSharpOfst.u1DetailGain[0], stSharpOfst.u1DetailGain[1], stSharpOfst.u1DetailGain[2]);
	LOG(2, "LTIGain     %d %d %d \n", 
        stSharpOfst.u1LTIGain[0], stSharpOfst.u1LTIGain[1], stSharpOfst.u1LTIGain[2]);
    LOG(2, "LTICoringZero     %d %d %d \n", 
        stSharpOfst.u1LTICorz[0], stSharpOfst.u1LTICorz[1], stSharpOfst.u1LTICorz[2]);
	
    LOG(0, "u1Edf1Th     %d %d %d \n", 
        stSharpOfst.u1Edf1Th[0], stSharpOfst.u1Edf1Th[1], stSharpOfst.u1Edf1Th[2]);
	
    LOG(0, "u1Edf2Th     %d %d %d %d \n", 
        stSharpOfst.u1Edf2Th[0], stSharpOfst.u1Edf2Th[1], stSharpOfst.u1Edf2Th[2], stSharpOfst.u1Edf2Th[3]);

    LOG(0, "u1Edf2FGain     %d %d %d \n", 
        stSharpOfst.u1Edf2FGain[0], stSharpOfst.u1Edf2FGain[1], stSharpOfst.u1Edf2FGain[2]);

    LOG(0, "u1Edf2DGain     %d %d %d  \n", 
        stSharpOfst.u1Edf2DGain[0], stSharpOfst.u1Edf2DGain[1], stSharpOfst.u1Edf2DGain[2]);

	
    LOG(0, "u1Edf2DGain     %d %d %d %d %d %d \n", 
        stSharpOfst.u1Edf2EGain[0], stSharpOfst.u1Edf2EGain[1], stSharpOfst.u1Edf2EGain[2],  stSharpOfst.u1Edf2EGain[3], stSharpOfst.u1Edf2EGain[4], stSharpOfst.u1Edf2EGain[5]);
	#endif
	
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */


FUN_MACRO(void DRVCUST_SetSRSLut(UINT8 * pTableA,UINT8 * pTableB))
#ifdef IMP_DRV_MAPLE_SET_API_C
{  
    LOG(2, "DRVCUST_SetSRSLut Table A Addr 0x%08x Table B Addr 0x%08x \n", (UINT32)pTableA, (UINT32)pTableB);

    if (pTableA && pTableB)
    {
        PhyAddrBuf_A = PHYSICAL((UINT32)pTableA);
        PhyAddrBuf_B = PHYSICAL((UINT32)pTableB);        
        u4BufFlag |= E_CUST_PQ_BUF_SRS;
    }
    else
    {
        LOG(0, "DRVCUST_SetSRSLut Parametes error !!!! \n");
    }    
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(UINT8 DRVCUST_CheckSetSRSLut(void))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    if (u4BufFlag&E_CUST_PQ_BUF_SRS)
	{
	    return SV_TRUE;
	}
	else
	{
	    return SV_FALSE;
	}
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(UINT8 DRVCUST_FlushPqSetting(void))
#ifdef IMP_DRV_MAPLE_SET_API_C
{  
	if(fgCriticalSection)
{    
		return SV_FALSE;
	}
	
    u4BufFlag |= E_CUST_PQ_BUF_FLUSH;

    //LOG(2, "DRVCUST_FlushPqSetting !!!! \n");

	return SV_TRUE;
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(UINT8 DRVCUST_CheckFlushPqSettingFlag(void))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    if (u4BufFlag&E_CUST_PQ_BUF_FLUSH)
	{
	    return SV_TRUE;
	}
	else
	{
	    return SV_FALSE;
	}
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_EnNoiseLevel(UINT8 u1Enable))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    vIO32WriteFldAlign(NR_NM_16, u1Enable, CUST_FORCE_NOISE_LVL_EN);
    //LOG(2, "DRVCUST_EnNoiseLevel %d \n", u1Enable);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(UINT8 DRVCUST_GetNoiseLevelEn(void))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    return IO32ReadFldAlign(NR_NM_16, CUST_FORCE_NOISE_LVL_EN);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetNoiseLevel(UINT8 u1NoiseLevel))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    vIO32WriteFldAlign(NR_NM_16, u1NoiseLevel, CUST_FORCE_NOISE_LVL);
    //LOG(2, "DRVCUST_SetNoiseLevel %d \n", u1NoiseLevel);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(UINT8 DRVCUST_GetNoiseLevel(void))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    return IO32ReadFldAlign(NR_NM_16, CUST_FORCE_NOISE_LVL);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_EnNoiseLevel2(UINT8 u1Enable))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    vIO32WriteFldAlign(NR_NM_16, u1Enable, CUST_FORCE_NOISE_LVL2_EN);
    //LOG(2, "DRVCUST_EnNoiseLevel %d \n", u1Enable);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(UINT8 DRVCUST_GetNoiseLevel2En(void))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    return IO32ReadFldAlign(NR_NM_16, CUST_FORCE_NOISE_LVL2_EN);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetNoiseLevel2(UINT8 u1NoiseLevel))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    vIO32WriteFldAlign(NR_NM_16, u1NoiseLevel, CUST_FORCE_NOISE_LVL2);
    //LOG(2, "DRVCUST_SetNoiseLevel %d \n", u1NoiseLevel);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(UINT8 DRVCUST_GetNoiseLevel2(void))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    return IO32ReadFldAlign(NR_NM_16, CUST_FORCE_NOISE_LVL2);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetPostSharpYLev(UINT8 * pYLev))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	if(pYLev==NULL)
	{
		LOG(0, "Err! Ptr Sharp ness pYLev null !!!!\n");
		return;
	}
    x_memcpy(u1YLevArrayBuf, pYLev, 17);
    u4BufFlag |= E_CUST_PQ_BUF_YLEV;
    //LOG(2, "DRVCUST_SetPostSharpYLev \n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */
FUN_MACRO(void DRVCUST_SetIbseYLev(UINT8 * pYLev))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	if(pYLev==NULL)
	{
		LOG(0, "Err! Ptr IBSE pYLev null !!!!\n");
		return;
	}
    x_memcpy(u1YLevIBSEArrayBuf, pYLev, 17);
    u4BufFlag |= E_CUST_PQ_BUF_IBSE_YLEV;
    //LOG(2, "DRVCUST_SetPostSharpYLev \n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_GetPostSharpYLev(UINT8 * pYLev))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    DRVCUST_GetYLevTable(pYLev);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_GetIbseYLev(UINT8 * pYLev))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    DRVCUST_GetIbseYLevTable(pYLev);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

#ifdef IMP_DRVCUST_LIB_C
UINT32 u4SrcTimingSize = sizeof(bCustomSrcTimingTbl);
UINT32 u4SrcGroupSize = sizeof(bCustomSourceGroup);
#else
extern UINT32 u4SrcTimingSize, u4SrcGroupSize;
#endif  /* IMP_DRVCUST_LIB_C */

FUN_MACRO(void DRVCUST_UpdateTimingGroup(UINT8 * pCustSrcTimingTbl,UINT8 * pCustSrcGroup))
#ifdef IMP_DRV_MAPLE_SET_API_C
{    
    if (pCustSrcTimingTbl && pCustSrcGroup)
    {           
        if ((pCustSrcTimingTbl[u4SrcTimingSize-1] == SOURCE_TYPE_TIMING_MAX)
            && (pCustSrcGroup[u4SrcGroupSize-1] == SOURCE_TYPE_TIMING_MAX)
            && (pCustSrcGroup[u4SrcGroupSize-2] == SOURCE_TYPE_TIMING_MAX))
        {
    	    x_memcpy(bCustomSrcTimingTbl, pCustSrcTimingTbl, u4SrcTimingSize);
    	    x_memcpy(bCustomSourceGroup, pCustSrcGroup, u4SrcGroupSize);
            bApiParseCustomQtyItem();
        }
        else
        {
            LOG(0, "DRVCUST_UpdateTimingGroup : Array mismatch !!! \n");
        }
    }
    else
    {
        LOG(0, "DRVCUST_UpdateTimingGroup : Null pointer !!! \n");
    }

    //LOG(2, "DRVCUST_UpdateTimingGroup \n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_PqSendDataToBe(UINT8 * pData,UINT32 u4Size))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    if (sony_be_func && sony_be_func->be_receive_from_pq)
    {
        sony_be_func->be_receive_from_pq(pData, u4Size);
    }
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_RegisterPqFunc(SONY_PQ_FUNC_T * pq_func))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    if (pq_func)
    {
        sony_pq_func = pq_func;
        LOG(2, "Sony PQ function registered \n");	
    }
    else
    {
        LOG(2, "Sony PQ function NULL \n");
    }
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_DeregisterPqFunc(void))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    sony_pq_func = NULL;    
    LOG(2, "Sony PQ function unregistered \n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_RegisterBeFunc(SONY_BE_FUNC_T * be_func))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    if (be_func)
    {
        sony_be_func = be_func;
        LOG(2, "Sony BE function registered \n");
		//DRVCUST_BE_Connect(0,0,0,0);
		//DRVCUST_BE_Connect(1,2,2,2);
		DRVCUST_BE_Connect(E_CUST_BE_TX_PATH_VIDEO,E_CUST_BE_SCL_TYPE_PQ,E_CUST_BE_PLANE_ORDER_0,SV_VP_MAIN);
		DRVCUST_BE_Connect(E_CUST_BE_TX_PATH_GFX,E_CUST_BE_SCL_TYPE_GFX,E_CUST_BE_PLANE_ORDER_2,SV_VP_NA);
	//	DRVCUST_BE_Connect(E_CUST_BE_TX_PATH_VIDEO,E_CUST_BE_SCL_TYPE_VIDEO,E_CUST_BE_PLANE_ORDER_1,SV_VP_PIP);//just for test
    }
    else
    {
        LOG(2, "Sony BE function NULL \n");
    }
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_DeregisterBeFunc(void))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	
    sony_be_func = NULL;    
    LOG(2, "Sony BE function unregistered \n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_RegisterBeGeneralFunc(SONY_BE_GEN_FUNC_T * be_gen_func))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    if (be_gen_func)
    {
        sony_be_gen_func = be_gen_func;
        LOG(2, "Sony BE General function registered \n");
    }
    else
    {
        LOG(2, "Sony BE General function NULL \n");
    }
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_DeregisterBeGeneralFunc(void))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    sony_be_gen_func = NULL;    
    LOG(2, "Sony BE General function unregistered \n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_RegisterPQGeneralFunc(SONY_PQ_GEN_FUNC_T * pq_gen_func))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	if(pq_gen_func)
	{
		sony_pq_gen_func = pq_gen_func;
        LOG(2, "Sony PQ General function registered \n");
	}
	else
	{	
		LOG(2, "Sony PQ General function NULL \n");
	}
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_DeRegisterPQGeneralFunc(void))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    sony_pq_gen_func = NULL;    
    LOG(2, "Sony PQ General function unregistered \n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */
FUN_MACRO(void DRVCUST_ResetSystem(E_CUST_RESET eReset))
#ifdef IMP_DRV_MAPLE_SET_API_C
{   
    switch (eReset)
    {
        case E_CUST_RESET_SHUTDOWN:                        
            PDWNC_EnterPowerDown(WAK_IRRX | WAK_RTC, (UINT32)PDWNC_POWER_DOWN_UNKNOWN);            
            break;
        default:
        case E_CUST_RESET_REBOOT:
            PDWNC_Reboot();
            break;
    }
    
    LOG(2, "DRVCUST_ResetSystem %d \n", eReset);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetEcsCommandReply(UINT8 * pData,UINT32 u4Size))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	
	if (u4Size <= 256) 
	{
		gu4EcsCommandReplySize = u4Size;
		x_memcpy(gu1EcsCommandReply, pData, u4Size);
	}
	
    //LOG(2, "DRVCUST_SetEcsCommandReply \n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(UINT32 DRVCUST_BePartitionWrite(E_CUST_BE_PART ePartId,UINT32 u4Offset,VOID * pvBuf,UINT32 u4BufSize))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	UINT64 u8Offset;
    UINT64 u8offsetTmp;
	UINT64 u4RelPartId=0 ;
    INT32  i4Ret, u4PartitionSize, u4FooterInfo;
    UINT8 u4Tmp0, u4Tmp1, u4Tmp2, u4Tmp3, u4BankIndexNum, u4DualFlagIsSupported;
    UINT8 _u4FooterInfo[8] = {0};
    UINT8 *pu4FooterInfo = _u4FooterInfo;

    LOG(2, "DRVCUST_BePartitionWrite\n");
	if(ePartId >= E_CUST_PART_MAX)
	{
		Printf("%s error : partid is invalid\n", __FUNCTION__);
		return 1 ;
}
	if (DRVCUST_InitQuery64(eBELPartitionId, &u4RelPartId) != 0 )
	{
		Printf("%s error query BE ID\n", __FUNCTION__);
		return 1;
	}

    u4RelPartId += ePartId ;
	u8Offset = ((UINT64)(u4RelPartId << 32)) | u4Offset ;

    /* Dual Bank Partition */
    if (ePartId == E_CUST_PART_FDAT || ePartId == E_CUST_PART_UDAT) {
        /* Read Bank Ctrl Info */
        u4PartitionSize     = DRVCUST_InitGet64((QUERY_TYPE_T)(eNANDFlashPartSize0 + u4RelPartId));
        u8offsetTmp = ((UINT64)((UINT64)u4RelPartId << 32)) | (u4PartitionSize - 32);
        MSDCPART_Read(u8offsetTmp, pu4FooterInfo, 8);
        u4Tmp0 = *pu4FooterInfo;
        u4Tmp1 = *(pu4FooterInfo+1);
        u4Tmp2 = *(pu4FooterInfo+2);
        u4Tmp3 = *(pu4FooterInfo+3);
        u4FooterInfo = ((UINT32)(u4Tmp0<<24)+(UINT32)(u4Tmp1<<16)+(UINT32)(u4Tmp2<<8)+(UINT32)u4Tmp3);

        u4DualFlagIsSupported = *(pu4FooterInfo+4);
        u4BankIndexNum        = *(pu4FooterInfo+5);

        if (u4FooterInfo == 0x4354524C && u4DualFlagIsSupported) {
            if (u4BankIndexNum == 0) {
                u8Offset += ((u4PartitionSize / 2) - 16);
                Printf("%s  u4BankIndexNum = 0: u8Offset => 0x%08x %ld\n", __FUNCTION__, u8Offset, u8Offset);
                i4Ret = MSDCPART_Write((UINT64)u8Offset, (UPTR)pvBuf, u4BufSize);

                if (i4Ret == 0) {
                    u4BankIndexNum = 1;
                    u8offsetTmp = ((UINT64)((UINT64)u4RelPartId << 32)) | (u4PartitionSize - 27);
                    MSDCPART_Write((UINT64)u8offsetTmp, (UPTR)&u4BankIndexNum, 1);
                }
            } else {
                Printf("%s u4BankIndexNum = 1: u8Offset => 0x%08x %ld\n", __FUNCTION__, u8Offset, u8Offset);
                i4Ret = MSDCPART_Write((UINT64)u8Offset, (UPTR)pvBuf, u4BufSize);

                 if (i4Ret == 0) {
                    u4BankIndexNum = 0;
                    u8offsetTmp = ((UINT64)((UINT64)u4RelPartId << 32)) | (u4PartitionSize - 27);
                    MSDCPART_Write((UINT64)u8offsetTmp, (UPTR)&u4BankIndexNum, 1);
                }
            }
        } else {
            i4Ret = MSDCPART_Write((UINT64)u8Offset, (UPTR)pvBuf, u4BufSize);
        }
    } else {
        /* Single Bank Partition */
        i4Ret = MSDCPART_Write((UINT64)u8Offset, (UPTR)pvBuf, u4BufSize);
    }
    return i4Ret;
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(UINT32 DRVCUST_SopqPartitionWrite(E_CUST_SPQ_PART ePartId,UINT32 u4Offset,VOID * pvBuf,UINT32 u4BufSize))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	UINT64 u8Offset;
	UINT64 u4RelPartId=0 ;
	INT32  i4Ret;
	
	LOG(2, "DRVCUST_SopqPartitionWrite\n");
	if(ePartId >= E_CUST_PART_SPMAX)
	{
		Printf("%s error : partid is invalid\n", __FUNCTION__);
		return 1 ;
	}
	
	if(ePartId == E_CUST_PART_SPQD)
	{
		if (DRVCUST_InitQuery64(eSPQDPartition, &u4RelPartId) != 0 )
		{
			Printf("%s error E_CUST_PART_SPQD ID\n", __FUNCTION__);
			return 1;
		}	
	}
	else
	{
		if (DRVCUST_InitQuery64(eSPQCPartition, &u4RelPartId) != 0 )
		{
			Printf("%s error eSPQCPartition ID\n", __FUNCTION__);
			return 1;
		}	
	}

	// u4RelPartId += ePartId ;
	u8Offset = ((UINT64)(u4RelPartId << 32)) | u4Offset ;

	i4Ret = MSDCPART_Write((UINT64)u8Offset, (UPTR)pvBuf, u4BufSize);
	return i4Ret;
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */


FUN_MACRO(void DRVCUST_SetBeDeviceInformation(E_BE_DEVICE device,VOID * pParam,UINT32 size))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	gBEDevice = device;
	gBEInfoPara = pParam;
	gBEDeviceInfoSize = size;
	UINT8 arPanelIDString_New_Recipe[ATV_PANEL_ID_STRING_LEN+1]={0};

	
	//get panel ID string forn New_Recipe_condition_data
	EEPROM_Read(0x10020, (UPTR)arPanelIDString_New_Recipe, 16);
	arPanelIDString_New_Recipe[ATV_PANEL_ID_STRING_LEN]='\0';
	Printf("4K New_Recipe_condition_data_PANEL_ID_STRING=%s \n",arPanelIDString_New_Recipe);

	//panel ID string forn 4KBE
	Printf("4K Panel ID String From 4KBE=%s \n",pParam);
	
	if (x_strncmp((const char *)pParam, (const char *)arPanelIDString_New_Recipe, ATV_PANEL_ID_STRING_LEN) == 0)	
	{
		Printf("4K Panel ID String From 4KBE = [New]Recipe Condition Data \n");
	}
	else
	{
		Printf("Panel ID String From 4KBE != [New]Recipe Condition Data \n");
		//Write  panel ID string forn 4KBE to [New]Recipe Condition Data
		if(device == PANEL_INFO)
		{
			if(CustomPanelLoadTableFromFlash(LOAD_PANEL_FROM_FLASH_BY_NAME, pParam))
			{
				EEPROM_Write(0x10020, pParam, size);
			}
		}		
		//LED blinking +turn 4K panel off
		GPIO_CustomLedCtrlFunc(eLedErrPanelID);
        #ifdef CC_SUPPORT_STR
		ostg_set_fgPanelPowerState(FALSE);//4K set pnael power off
		#endif
	}
	
	//LOG(2, "DRVCUST_SetBeDeviceInformation\n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */


FUN_MACRO(void DRVCUST_SetBeDeviceErrorDetect(E_BE_ERROR_DETECT Efactor))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	gBEErrorDetect |= Efactor;
	//LOG(2, "DRVCUST_SetBeDeviceInformation: 0x%04x\n", Efactor);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRV_CUST_SetBEDeviceVersion(UINT8 u1Number,UINT8 * pVersion))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    gBEVersionNum = u1Number;

	if(gBEVersion != NULL)
	{
		x_mem_free(gBEVersion);
		gBEVersion = NULL;
	}
		
    if ((gBEVersion = (UINT8*)x_mem_alloc(gBEVersionNum*20)) == NULL)
    {
        LOG(0, "DRVCUST_SetBeDeviceInformation: gBEVersion memory allocation fail!\n");
    }
    else
    {
        x_memcpy(gBEVersion, pVersion, gBEVersionNum*20);
    }
    
    if (!fgBEVersionIsSet)
    {
        fgBEVersionIsSet = TRUE;
    }
    //LOG (2, "DRVCUST_SetBeDeviceInformation\n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(UINT8 QueryBEDeviceVersionNum(void))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    return gBEVersionNum;
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(INT32 QueryBEDeviceVersion(UINT8 * pOut))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    if (pOut == NULL)
   {
        LOG(0, "DRVCUST_GetBEDeviceVersion: output pointer is null\n");
        return -1;
   }
   else
   {
        if (fgBEVersionIsSet)
        {
            x_memcpy(pOut, gBEVersion, gBEVersionNum*20);
            return 0;
        }
        else
        {            
            LOG(0, "DRVCUST_GetBEDeviceVersion: BE version has not been set\n");
            return -1;
        }
   }
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetPqColMatrixParam(UINT8 u1Upof_ext,UINT8 u1Ucof_ext,UINT8 u1Ubof_ext))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	u2MatrixContrastBuf = u1Upof_ext;      
	u2MatrixColorBuf = u1Ucof_ext;      
	u2MatrixBrightnessBuf = u1Ubof_ext;      
    u4BufFlag |= E_CUST_PQ_BUF_MATRIX;
	//LOG(2, "DRVCUST_SetPqColMatrixParam\n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_GetPqColMatrixParam(UINT8 * u1Cont_ext,UINT8 * u1Color_ext,UINT8 * u1Bri_ext))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    *u1Cont_ext = IO32ReadFldAlign(GLOBAL_ADJ_04, EXT_ADJ_CONT);
    *u1Color_ext = IO32ReadFldAlign(GLOBAL_ADJ_04, EXT_ADJ_SAT);
    *u1Bri_ext = IO32ReadFldAlign(GLOBAL_ADJ_04, EXT_ADJ_BRI);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetPqNewPartialS(UINT8 * u1PointL,UINT8 * u1PointM,UINT8 * u1PointH))
#ifdef IMP_DRV_MAPLE_SET_API_C
{     
    if (u1PointL != NULL)
    {
        x_memcpy(u1SceSGain1, u1PointL, SCE_HUE_SLICE);
    }
    else
    {
        LOG(0, "DRVCUST_SetPqNewPartialSFailed u1PointL!!!!\n");
        return;
    }

	if (u1PointM != NULL)
    {
        x_memcpy(u1SceSGain2, u1PointM, SCE_HUE_SLICE);
    }
    else
    {
        LOG(0, "DRVCUST_SetPqNewPartialSFailed u1PointM!!!!\n");
        return;
    }

	if (u1PointH != NULL)
    {
        x_memcpy(u1SceSGain3, u1PointH, SCE_HUE_SLICE);
    }
    else
    {
        LOG(0, "DRVCUST_SetPqNewPartialSFailed u1PointH!!!!\n");
        return;
    }
	
	u4BufFlag |= E_CUST_PQ_BUF_PARTIALS;
    u4BufFlag |= E_CUST_PQ_BUF_SCE;
    //LOG(2, "DRVCUST_SetPqNewPartialS \n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetPqPartialY(UINT8 * u1Point))
#ifdef IMP_DRV_MAPLE_SET_API_C
{     
    if (u1Point != NULL)
    {
        x_memcpy(u1SceYSlope, u1Point, SCE_LUMA_HUE_SLICE);
    }
    else
    {
        LOG(0, "DRVCUST_SetPqPartialY Failed !!!!\n");
        return;
    }
    
    u4BufFlag |= E_CUST_PQ_BUF_SCE;
	u4BufFlag |= E_CUST_PQ_BUF_PARTIALY;
    //LOG(2, "DRVCUST_SetPqPartialY \n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetScalerCoefLumaH(UINT32 * u4Array))
#ifdef IMP_DRV_MAPLE_SET_API_C
{     
	vDrvSCPQSetSramCoeff(COEFTYP_HOR_Y, u4Array);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetScalerCoefChromaH(UINT32 * u4Array))
#ifdef IMP_DRV_MAPLE_SET_API_C
{     
	vDrvSCPQSetSramCoeff(COEFTYP_HOR_C, u4Array);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetScalerCoefLumaV(UINT32 * u4Array))
#ifdef IMP_DRV_MAPLE_SET_API_C
{     
	vDrvSCPQSetSramCoeff(COEFTYP_VER_Y, u4Array);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetScalerCoefChromaV(UINT32 * u4Array))
#ifdef IMP_DRV_MAPLE_SET_API_C
{     
	vDrvSCPQSetSramCoeff(COEFTYP_VER_C, u4Array);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetLdHwParam(CUST_LD_HW_PARAM_T * pLDHWParam))
#ifdef IMP_DRV_MAPLE_SET_API_C
{     
	vDrvLcDimSetHWParam((LCDIM_HW_PARAM_T *)pLDHWParam);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetLdSwParam(CUST_LD_SW_PARAM_T * pLDSWParam))
#ifdef IMP_DRV_MAPLE_SET_API_C
{     
	vDrvLcDimSetSWParam((LCDIM_SW_PARAM_T *)pLDSWParam);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetLdHwTable(CUST_LD_HW_TABLE_T * pLDHWTable))
#ifdef IMP_DRV_MAPLE_SET_API_C
{     
	vDrvLcdimWriteDimTable(pLDHWTable->u2LDDimTable);
    vDrvLcdimWriteGainTable(pLDHWTable->u2LDGainTable);
    vDrvLcdimWriteGainLimitTable(pLDHWTable->u2LDGainLimitTable); 
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetLdSwTable(CUST_LD_SW_TABLE_T * pLDSWTable))
#ifdef IMP_DRV_MAPLE_SET_API_C
{     
	vDrvLcDimSetSWTable(pLDSWTable->u2LDGainLimitTable_LOW_BND, pLDSWTable->u2LDGainLimitTable_UP_BND);
	//LOG(2, "DRVCUST_SetLdSwTable \n");
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetPqSwVersion(UINT8 * pData))
#ifdef IMP_DRV_MAPLE_SET_API_C
{     

}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

extern UINT8 bIsMetaData;
extern UINT8 u1MetaDataVerify;

FUN_MACRO(void DRVCUST_SetPqMetaData(CUST_PQ_META_DATA_T * pPqMetaData))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    if(bIsMetaData || u1MetaDataVerify)
    {
        FBM_POOL_T *prPool = FBM_GetPoolInfo(FBM_POOL_TYPE_SCPOS_PIP);
        if(prPool == NULL)
        {
            LOG(0, "PqMetaData memory request fail\n");
            return ;
        }
    
        SCPIP_WRITE_FLD(SCPIP_DRAM_P_1F, 0, DRAM_P_1F_DRAM2_IMPORT_EN);
        TranMetadataToDram((UINT8*)VIRTUAL(prPool->u4Addr), &(pPqMetaData->u1DataBody[0]), pPqMetaData->u2DataSize);
    
    }
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */
#define BLOCK_HEIGHT    (8)
#define BLOCK_WIDTH     (256)
#define BLOCK_SIZE      (2048) // (8*256)
#define LINE_LENGHT     (1920)
#define SIZE_LENGHT     (2)

FUN_MACRO(void TranMetadataToDram(UINT8 * pDest,UINT8 * pSrc,UINT16 u4Size))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
    UINT32 u4CopySize=0, u4DestIdx=0, u4SrcIdx=0, u4Processed=0;
    BOOL   fgSwitchBlockLine=FALSE, fgFirstBlockLineSwitched=FALSE;
    UINT8 *pTmpDest=pDest, *pTmpSrc=pSrc,u1CurLine=1;

    // Assign the MetaData size
    *pTmpDest = (UINT8)u4Size;
    *(pTmpDest+1) = (UINT8)(u4Size>>8);
    pTmpDest += SIZE_LENGHT;

    // Speical process the first block rest data
    u4CopySize = (u4Size > BLOCK_WIDTH-SIZE_LENGHT) ? (BLOCK_WIDTH-SIZE_LENGHT) : u4Size;
    x_memcpy((void *)pTmpDest, (void *)pTmpSrc, u4CopySize);

    // Init for while Loop
    pTmpDest    = pDest;
    u4Processed = u4CopySize;
    u4SrcIdx    = u4CopySize;

    // Process the rest MetaData
    while (u4Processed < u4Size)
    {
        u4CopySize = ((LINE_LENGHT-u4SrcIdx)>BLOCK_WIDTH) ? (BLOCK_WIDTH) : ((fgSwitchBlockLine=TRUE),(LINE_LENGHT-u4SrcIdx));
        // Sepcail process for the first Block Line
        if ((fgFirstBlockLineSwitched==FALSE) && fgSwitchBlockLine)
        {
            fgFirstBlockLineSwitched = TRUE;
            u4CopySize = LINE_LENGHT%BLOCK_WIDTH;
        }
        u4DestIdx  = (((u4SrcIdx+BLOCK_WIDTH-1)/BLOCK_WIDTH)*BLOCK_HEIGHT*BLOCK_WIDTH);
        u4CopySize = (u4Size-u4Processed > u4CopySize) ? u4CopySize : (u4Size-u4Processed);
 
        x_memcpy((void *)pTmpDest+u4DestIdx, (void *)pTmpSrc+u4SrcIdx, u4CopySize);
        #if 0
        Printf("0x%X<==0x%X %d Size:%u  Ratio:%u/%u Idx:%u TestData(0x%08X)\n", (void *)pTmpDest+u4DestIdx, (void *)pTmpSrc+u4SrcIdx,u1CurLine, 
               u4CopySize, u4Processed, u4Size, u4SrcIdx, *(UINT32 *)(pTmpDest+u4DestIdx));
        #endif
        if (fgSwitchBlockLine)
        {

            if(u1CurLine==BLOCK_HEIGHT)
            {
                pTmpDest=pTmpDest+u4DestIdx+BLOCK_WIDTH;
                u1CurLine=0;
            }
            else
            {
                pTmpDest=pTmpDest+u4DestIdx-BLOCK_WIDTH*BLOCK_HEIGHT*(LINE_LENGHT/BLOCK_WIDTH)+BLOCK_WIDTH;
            }
            pTmpSrc += (u4SrcIdx+u4CopySize);
            fgSwitchBlockLine = FALSE;
            u4SrcIdx   = 0;
            u4DestIdx  = 0;
            u4CopySize = 0;
            u1CurLine++;


        }
        else
        {
            u4SrcIdx += u4CopySize;
        }
        u4Processed += u4CopySize;
    }

    // Dcache invalid
    if (u4Size <= BLOCK_WIDTH-SIZE_LENGHT)
    {
        HalFlushDCacheMultipleLine((UPTR)pDest, (USIZE)(u4Size+SIZE_LENGHT));
    }
    else
    {
        HalFlushDCacheMultipleLine((UPTR)pDest, (USIZE)(pTmpDest+u4DestIdx+u4CopySize-pDest));
    }

    return ;
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

//sce capture setting function
FUN_MACRO(void DRVCUST_SetScePixMonCapEnable(BOOL en))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	vIO32WriteFldAlign(DBG_CFG_MAIN, en, SCE_CAP_EN);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(CUST_SCE_CAP_DATA_T * DRVCUST_SetScePixMonPos(CUST_CAP_POS_T * pPos))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	//CUST_SCE_CAP_DATA_T CUST_SCE_CAP_DATA;
	
	vIO32WriteFldAlign(POS_MAIN, pPos->u2X, SCE_POS_X);
	vIO32WriteFldAlign(POS_MAIN, pPos->u2Y, SCE_POS_Y);

	DRVCUST_GetScePixMonData(&CUST_SCE_CAP_DATA);

	return &CUST_SCE_CAP_DATA;
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

//sce ink setting function
FUN_MACRO(void DRVCUST_SetScePixMonInkEnable(BOOL en))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	vIO32WriteFldAlign(DBG_CFG_MAIN, en, INK_EN);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetScePixMonInkColor(CUST_CAP_DATA_T * pData))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	vIO32WriteFldAlign(INK_DATA_MAIN, pData->u2Y_G, INK_DATA_Y);
	vIO32WriteFldAlign(INK_DATA_MAIN, pData->u2Cb_B, INK_DATA_CB);
	vIO32WriteFldAlign(INK_DATA_MAIN_CR, pData->u2Cr_R, INK_DATA_CR);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

// ostg capture setting function
FUN_MACRO(void DRVCUST_SetOstgPixMonCapEnable(BOOL en))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	vIO32WriteFldAlign(DUMP_00, en, DUMP_EN);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(CUST_CAP_DATA_T * DRVCUST_SetOstgPixMonPos(CUST_CAP_POS_T * pPos))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	//CUST_CAP_DATA_T CUST_CAP_DATA;
		
	vIO32WriteFldAlign(DUMP_01, pPos->u2X, POS_X);
	vIO32WriteFldAlign(DUMP_01, pPos->u2Y, POS_Y);

	DRVCUST_GetOstgPixMonData(&CUST_CAP_DATA);

	return &CUST_CAP_DATA;
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

//ostg curse setting
FUN_MACRO(void DRVCUST_SetOstgPixMonCurseColor(CUST_CAP_DATA_T * pColor))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	vIO32WriteFldAlign(DUMP_02, pColor->u2Y_G, POS_G);
	vIO32WriteFldAlign(DUMP_02, pColor->u2Cr_R, POS_R);
	vIO32WriteFldAlign(DUMP_03, pColor->u2Cb_B, POS_B);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_Set4BandFilterRang(CUST_4BAND_FILTER_RANGE * pData))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	if(pData!=NULL)
	{
        x_memcpy(&CUST_4BAND_HIST_FILTER_RANGE, pData, sizeof(CUST_4BAND_FILTER_RANGE));
	}
	else
	{		
        LOG(0, "DRVCUST_Set4BandFilterRang Failed !!!!\n");
	}
	u4BufFlag |= E_CUST_PQ_BUF_4BAND_FREQ_RANGE;
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_Set4BandHFilter(CUST_4BAND_H_FILTER * pData))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	if(pData!=NULL)
	{
        x_memcpy(&CUST_4BAND_HIST_FILTER, pData, sizeof(CUST_4BAND_H_FILTER));
	}
	else
	{		
        LOG(0, "DRVCUST_Set4BandHFilter Failed !!!!\n");
	}
	u4BufFlag |= E_CUST_PQ_BUF_4BAND_FREQ_FILTER;
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_SetOsdPixCountAlphaThresh(UINT8 u1Thresh))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	IO_WRITE32MSK(OSD_MIXER_OSTG1, 0, u1Thresh, OSD_MIXER_INDEX_THD_MASK);
    IO_WRITE32MSK(OSD_MIXER_OSTG2, 0, u1Thresh, OSD_MIXER_INDEX_THD_MASK);
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(INT32 DRVCUST_SetColorimetryConvTable(CUST_COL_CONV_TABLE_PARAM_T * pColConvTableParam))
#ifdef IMP_DRV_MAPLE_SET_API_C
{	
	UINT8 i;
	if(pColConvTableParam==NULL)
	{
		LOG(0, "Err!pColConvTableParam initial Failed !!!!\n");
		return -1;
	}

	if(pColConvTableParam->type>E_MODIFY_BY_MATRIX_COEFFICIENT)
	{
		LOG(0, "Err! type > 2 !!!!\n");
		return -1;
	}
	else if((pColConvTableParam->type==E_MODIFY_BY_CONVERT_PATTERN)||(pColConvTableParam->type==E_MODIFY_BY_MATRIX_COEFFICIENT))
	{
		if(!DRVCUST_SetConTblDFT(pColConvTableParam->input, pColConvTableParam->block, pColConvTableParam->src, pColConvTableParam->dst))
		{
			return -1;
		}
	}
	else if((pColConvTableParam->block==E_MTX_R2Y)&&(pColConvTableParam->type==E_MODIFY_BY_MATRIX_COEFFICIENT))
		{
			LOG(0, "Err! R2Y no need to set param !!!!\n");
			return -1;
		}

	else
	{
          
          }
		x_memcpy(&CUST_COL_CONV_TABLE_PARAM[u1ConvTblParamIDX], pColConvTableParam, sizeof(CUST_COL_CONV_TABLE_PARAM_T));//n is needed to defined
		u1ConvTblParamIDX++;
		
		for(i=0;i<15;i++)
		{
			LOG(0, "CUST_COL_CONV_TABLE_PARAM[%d]=%d !!!!\n",u1ConvTblParamIDX,CUST_COL_CONV_TABLE_PARAM[u1ConvTblParamIDX-1].matrix[i]);
		}
		LOG(0, "u1ConvTblParamIDX=%d !!!!\n",u1ConvTblParamIDX);
		return 0;
	
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */
FUN_MACRO(INT32 DRVCUST_SetDolbyConfigData(UPTR u4Offset,UINT32 u4Size))
#ifdef IMP_DRV_MAPLE_SET_API_C
{	
#ifdef CC_SUPPORT_DOLBY_VISION

	static UINT8 u1Smrt_Pic_DV_IDX = 0;
	
	u1Smrt_Pic_DV_IDX= (~u1Smrt_Pic_DV_IDX)&0x01;
	vDolbySetConfiFile(u1Smrt_Pic_DV_IDX,u4Offset,u4Size);
	LOG(3,"u1Smrt_Pic_DV_IDX=%d,u4Offset=0x%x;u4Size=%d\n",u1Smrt_Pic_DV_IDX,u4Offset,u4Size);
#endif
	return 0;
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_RegisterBeExtFunc(SONY_BE_EXT_FUNC_T * pfnBeCb))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	if(pfnBeCb)
	{
		sony_be_ext_func = pfnBeCb;
        LOG(2, "Sony Be Ext function registered \n");
	}
	else
	{
		LOG(2, "Sony Be Ext function NULL \n");
	}
}
#endif  /* IMP_DRV_MAPLE_SET_API_C */

FUN_MACRO(void DRVCUST_EnSetTnr(UINT8 u1Enable))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	//if(IO32ReadFldAlign(TNR_FW_REG_002, TNR_CUST_SET_EN_DEBUG))
	//{
		vIO32WriteFldAlign(TNR_FW_REG_002, u1Enable, TNR_CUST_SET_EN); //monitor
		gU1EnSetTnr = u1Enable;
	//}

}
#endif  /* IMP_DRV_MAPLE_SET_API_C */
FUN_MACRO(void DRVCUST_SetTnr(CUST_TNR_BLEND_RATIO * pTnrSet))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	if(pTnrSet==NULL)
	{
		LOG(0, "Err! Ptr pTnrSet null !!!!\n");
		return;
	}

	pTnrSet->u1BlendRatioBlky = CLIP(pTnrSet->u1BlendRatioBlky, 0, 31);
	pTnrSet->u1BlendRatioDe = CLIP(pTnrSet->u1BlendRatioDe, 0, 31);
	pTnrSet->u1BlendRatioTxtr = CLIP(pTnrSet->u1BlendRatioTxtr, 0, 31);
	pTnrSet->u1BlendRatioMv = CLIP(pTnrSet->u1BlendRatioMv, 0, 31);
	pTnrSet->u1FltStrMax = CLIP(pTnrSet->u1FltStrMax, 0, 32);

	//if(IO32ReadFldAlign(TNR_FW_REG_002, TNR_CUST_SET_EN_DEBUG))
	//{
		vIO32WriteFldAlign(TNR_FW_REG_001, pTnrSet->u1BlendRatioBlky, TNR_BLEND_RATIO_BLKY);
		vIO32WriteFldAlign(TNR_FW_REG_001, pTnrSet->u1BlendRatioDe, TNR_BLEND_RATIO_DE);
		vIO32WriteFldAlign(TNR_FW_REG_001, pTnrSet->u1BlendRatioTxtr, TNR_BLEND_RATIO_TXTR);
		vIO32WriteFldAlign(TNR_FW_REG_001, pTnrSet->u1BlendRatioMv, TNR_BLEND_RATIO_MV);
		vIO32WriteFldAlign(TNR_FW_REG_002, pTnrSet->u1FltStrMax, TNR_FLT_STR_MAX);
	//}
}

#endif  /* IMP_DRV_MAPLE_SET_API_C */
FUN_MACRO(void DRVCUST_SetDV_GDLog(UINT8 u1OnOff))
#ifdef IMP_DRV_MAPLE_SET_API_C
{
	vIO32WriteFldAlign(DOLBY_DEBUG, u1OnOff, DOLBY_DEBUG_GD_LOG);
}

#endif  /* IMP_DRV_MAPLE_SET_API_C */

