#ifndef MAPLE_BACKLIGHT_DRV_H
#define MAPLE_BACKLIGHT_DRV_H

enum
{
    DYNAMIC_CONTRAST_RATIO_100PERCENT = 0,
    DYNAMIC_CONTRAST_RATIO_150PERCENT,
    DYNAMIC_CONTRAST_RATIO_200PERCENT,
    DYNAMIC_CONTRAST_END
};

typedef struct structBacklightCurve
{
    UINT8 x1;
    UINT8 x2;
    UINT8 x3;
    UINT8 x4;
    UINT8 y0;
    UINT8 y1;
    UINT8 y2;
    UINT8 y3;
    UINT8 y4;
    INT16 m0;
    INT16 m1;
    INT16 m2;
    INT16 m3;
    INT16 m4;
} structBacklightCurve;

typedef enum
{
    eNormal   = 0,
    eHigh_Fix = 1,
    eLow_Fix  = 2
} Out_Mode;

typedef struct
{
    Out_Mode Mode;
    UINT16 u2duty;
} PWM_Status;

typedef struct
{
    INT32 u4Start;
    UINT32 u4High; 
    UINT32 u4Low;
    INT32 u4Phase;
} M_SCANPWM_T;

#endif /* MAPLE_BACKLIGHT_DRV_H */
